#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second 
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define make_unique(x) sort(all(x)), x.erase(unique(all(x)), x.end())

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 Rng(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const int N = 1e6 + 200;
const int M = 1e6;
const int inf = 2e9 + 3;
const ll INF = 1e18;

int T;
int n;
int h[N], w[N];
int saw[N];

void solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> h[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> w[i];
        saw[w[i]] = 0;
    }
    for (int i = 1; i <= n; ++i) {
        if (saw[w[i]] > 0) {
            cout << -1 << '\n';
            return;
        }
        saw[w[i]] = h[i];
    }
    sort(w + 1, w + n + 1);
    reverse(w + 1, w + n + 1);
    int mx = inf;
    for (int i = 1; i <= n; ++i) {
        if (i > 1 && w[i] == w[i - 1]) continue;
        if (w[i] - saw[w[i]] > mx) {
            cout << -1 << '\n';
            return;
        }
        if (w[i] - saw[w[i]] < 0) {
            cout << -1 << '\n';
            return;
        }
        mx = w[i] - saw[w[i]];
    }
    cout << w[1] - saw[w[1]] << '\n';
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> T;
    while (T--) solve();
}
