#include <iostream>
#include <algorithm>

using namespace std;

int t, n;
pair<int, int> p[11111];

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> p[i].first;
    }
    for (int i = 0; i < n; i++) {
        cin >> p[i].second;
    }
    sort(p, p + n);
    for (int i = 1; i < n; i++) {
        if (p[i - 1].second > p[i].second || p[i].first > p[i].second) {
            cout << "-1" << endl;
            return;
        }
    }
    long long ans = 0;
    for (int i = 1; i < n; i++) {
        int L = p[i].first - p[i - 1].first;
        int R = p[i].second - p[i - 1].second;
        if (L > R) {
            cout << "-1" << endl;
            return;
        }
        ans += R - L;
    }
    if (p[n - 1].second - ans < p[n - 1].first) {
        cout << "-1" << endl;
    } else {
        cout << p[n - 1].second - p[n - 1].first << endl;
    }
}

int main() {

    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
