#include <iostream>
#include <algorithm>
#include <string>
#include <set>

using namespace std;

int t;
int n, m;
string s[111];

bool is_infinity(string s) {
    for (int i = 1; i < s.size(); i++) {
        if (s[i] != s[i - 1]) return false;
    }
    return true;
}

int calc(string s, char c) {
    int i = 0;
    while (i < s.size() && s[i] == c) i++;
    return i;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }

    set<char> st;
    for (int i = 0; i < n; i++) {
        if (is_infinity(s[i])) {
            st.insert(s[i][0]);
        }
    }

    if (st.size() == m) {
        cout << "NO\n";
        return 0;
    }

    int ans = (int)1e9;
    char best = 'a';
    for (char c = 'a'; c < 'a' + m; c++) {
        if (st.find(c) != st.end()) continue;
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            cnt += calc(s[i], c);
        }
        if (cnt < ans) {
            ans = cnt;
            best = c;
        }
    }

    for (int i = 0; i < ans + 1; i++) cout << best;
    cout << '\n';

    return 0;
}
