import java.util.*;

public class Main {
    static final int MOD = 998244353;

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt(); 
        StringBuilder sb = new StringBuilder();
        while (t-- > 0) {
            int n = sc.nextInt(); 
            int m = sc.nextInt(); 
            int k = sc.nextInt(); 
            if (m >= n) {
                sb.append(0).append("\n");
                for (int i = 0; i < 2 * m; i++) sc.nextInt();
                continue;
            }
            for (int i = 0; i < 2 * m; i++) sc.nextInt();
            int components = n - m;
            long result = (long) k * modPow(k - 1, components - 1, MOD) % MOD;
            sb.append(result).append("\n");
  }
        System.out.print(sb);
    }
    private static long modPow(long base, int exp, int mod) {
        long result = 1;
        while (exp > 0) {
         if ((exp & 1) == 1) result = result * base % mod;
            base = base * base % mod;
          exp >>= 1;
        }
        return result; }
}
