//#pragma comment(linker, "/stack:20000000")
//#pragma GCC optimize("Ofast,O3,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx2,bmi,bmi2,popcnt,lzcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

#define ll long long
#define int ll
#define f first
#define s second
#define fi first
#define se second
#define ss size()
#define pii pair < int, int >
#define si set < int >
#define vi vector < int >
#define spii set < pii >
#define mii map < int, int >
#define umii unordered_map < int, int >
#define FOR(i, l, r) for (int i = l; i <= r; i++)
#define ROF(i, r, l) for (int i = r; i >= l; i--)
#define FOR1(i, l, r, x) for (int i = l; i <= r; i += x)
#define all(v) v.begin(), v.end()
#define srt(a, n) sort(a + 1, a + n + 1)
#define mp make_pair
#define rvs(a, n) reverse(a + 1, a + n + 1)
/*#define fi(n) for(ll i = 0; i < n; i++)
#define fj(n) for(ll j = 0; j < n; j++)
#define fk(n) for(ll k = 0; k < n; k++)
#define fio(n) for(ll i = 1; i < n; i++)
#define fjo(n) for(ll j = 1; j < n; j++)
#define fko(n) for(ll k = 1; k < n; k++)*/

template<class T, class comp=less<T> > using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, comp, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
inline int rng(int l, int r) {return (rnd()%(r-l+1) + l);}
template <class T, class U> bool emin(T& a, const U& b) {return b < a ? a = b, 1 : 0;}
template <class T, class U> bool emax(T& a, const U& b) {return b > a ? a = b, 1 : 0;}
template <class T, class U> bool erase(T& t, const U& u){
    auto it = t.find(u);
    if (it != t.end()) {t.erase(it); return 1;}
    return 0;
}

#define dbg(...) do { cout << "DBG: " << (#__VA_ARGS__) << ": "; dbg_vals(__VA_ARGS__); cout << "\n";} while (0);
template<typename iter, typename=decltype(declval<iter>().begin()), typename=enable_if<!is_convertible<iter, string>::value>> ostream& operator<<(ostream& out, const iter& x) { for(const auto& i : x) out << i << ' '; return out; }
template<typename T>void dbg_vals(T x){ cout << x; }
template<typename T, typename... Args> void dbg_vals(T x, Args... args){ dbg_vals(x); cout << " | "; dbg_vals(args...); }

const ll INF = 1e15 + 9;
const int N = 1e3 + 40, inf = 1e9 + 7, T = 4 * N, mod = 998244353, dx[] = {-1, 0, 1, 0}, dy[] = {0, 1, 0, -1};
int n, m, e, f, w, l, r, id, timer;

char c[N][N];
int a[N][N], us[N][N], p1[N][N], b[N][N], p2[N][N], p[N][N];

bool dfs1(int x, int y, int turn)
{
    if (c[x][y] == 'f') return 1;
    us[x][y] = 1;
    //a[x][y] = 1;
    //cout << x << " " << y << " " << turn << endl;
        turn--;
        turn = (turn + 4) % 4;
    FOR (i, 0, 3)
    {
        int nx = x + dx[turn];
        int ny = y + dy[turn];
        if (c[nx][ny] == '#' || us[nx][ny] || nx < 1 || nx > n || ny < 1 || ny > m) {}
        else {
            if (dfs1(nx, ny, turn)) return a[x][y] = 1;
        }
        turn++;
        turn %= 4;
    }
    return 0;
}

bool dfs2(int x, int y, int turn)
{
    if (c[x][y] == 'f') return 1;
    us[x][y] = 1;
    //b[x][y] = 1;
    //cout << x << " " << y << " " << turn << endl;
    turn++;
    turn %= 4;
    ROF (i, 3, 0)
    {
        int nx = x + dx[turn];
        int ny = y + dy[turn];
        if (c[nx][ny] == '#' || us[nx][ny] || nx < 1 || nx > n || ny < 1 || ny > m) {}
        else {
            if (dfs2(nx, ny, turn)) return b[x][y] = 1;
        }
        turn--;
        turn = (turn + 4) % 4;
    }
    return 0;
}

int geta(int x1, int y1, int x2, int y2)
{
    return p1[x2][y2] - p1[x1 - 1][y2] - p1[x2][y1 - 1] + p1[x1 - 1][y1 - 1];
}
int getb(int x1, int y1, int x2, int y2)
{
    return p2[x2][y2] - p2[x1 - 1][y2] - p2[x2][y1 - 1] + p2[x1 - 1][y1 -1];
}
int getc(int x1, int y1, int x2, int y2)
{
    return p[x2][y2] - p[x1 - 1][y2] - p[x2][y1 - 1] + p[x1 - 1][y1 -1];
}

bool ch(int x1, int y1, int x2, int y2)
{
    return (getb(x1, y1, x2, y2) > 0);
}

void solve()
{
    int x = 0, y = 0, z = 0;

    cin >> n >> m;
    int fx = 0, fy = 0;
    FOR (i, 1, n)
    {
        FOR (j, 1, m)
        {
            cin >> c[i][j];
            a[i][j] = 0;
            p[i][j] = 0;
            b[i][j] = 0;
            p1[i][j] = 0;
            p2[i][j] = 0;
            if (c[i][j] == 's')
            {
                x = i;
                y = j;
            }
            if (c[i][j] == 'f')
            {
                fx = i;
                fy = j;
            }
        }
    }

    if (mp(fx, fy) < mp(x, y))
    {
        swap(c[x][y], c[fx][fy]);
        x = fx;
        y = fy;
    }

    FOR (i, 1, n)
    {
        FOR (j, 1, m) us[i][j] = 0;
    }
    int x1 = x, y1 = y;
    while (c[x1][y] != '#' && x1 > 0) x1--;
    x1++;
    while (c[x][y1] != '#' && y1 > 0) y1--;
    y1++;
    dfs1(x1, y, 1);
    //cout << endl;
    FOR (i, 1, n)
    {
        FOR (j, 1, m) us[i][j] = 0;
    }
    dfs2(x, y1, 2);
    a[x][y] = b[x][y] = 0;

    FOR (i, 1, n)
    {
        FOR (j, 1, m)
        {
            p1[i][j] = p1[i - 1][j] + p1[i][j - 1] - p1[i - 1][j - 1] + a[i][j];
            p2[i][j] = p2[i - 1][j] + p2[i][j - 1] - p2[i - 1][j - 1] + b[i][j];
            p[i][j] = p[i - 1][j] + p[i][j - 1] - p[i - 1][j - 1] + (c[i][j] == '#' || c[i][j] == 's' || c[i][j] == 'f');
        }
    }
    f = inf;

    FOR (i, 1, n)
    {
        FOR (j, 1, m)
        {
            if (a[i][j])
            {
                l = 1;
                r = n - i + 1;
                while (l <= r)
                {
                    int mi = (l + r) / 2;
                    if (ch(i, j, i + mi - 1, j))
                    {
                        if (getc(i, j, i + mi - 1, j) == 0) emin(f, mi);
                        r = mi - 1;
                    }
                    else
                    {
                        l = mi + 1;
                    }
                }

                l = 1;
                r = m - j + 1;
                while (l <= r)
                {
                    int mi = (l + r) / 2;
                    if (ch(i, j, i, j + mi - 1))
                    {
                        if (getc(i, j, i, j + mi - 1) == 0) emin(f, mi);
                        r = mi - 1;
                    }
                    else
                    {
                        l = mi + 1;
                    }
                }


                l = 1;
                r = j;
                while (l <= r)
                {
                    int mi = (l + r) / 2;
                    if (ch(i, j - mi + 1, i, j))
                    {
                        if (getc(i, j - mi + 1, i, j) == 0) emin(f, mi);
                        r = mi - 1;
                    }
                    else
                    {
                        l = mi + 1;
                    }
                }

                l = 1;
                r = i;
                while (l <= r)
                {
                    int mi = (l + r) / 2;
                    if (ch(i - mi + 1, j, i, j))
                    {
                        if (getc(i - mi + 1, j, i, j) == 0) emin(f, mi);
                        r = mi - 1;
                    }
                    else
                    {
                        l = mi + 1;
                    }
                }
            }
        }
    }
    cout << (f == inf ? -1 : f);
}

signed main(){
    #ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
    #else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #endif // LOCAL

    int _ = 1;
    cin >> _;
    while (_--)
    {
        solve();
        cout << endl;
    }
}
