#include <bits/stdc++.h>
#define pb push_back
#define ff first
#define ss second
#define goodluck ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define int long long
#define ENDL "\n"
using namespace std;

#define L 2 * x + 1
#define R 2 * x + 2
#define M (xl + xr) / 2
#define LL xl, M
#define RR M, xr

vector<int> t, d;


void build(int x, int xl, int xr, vector<int>& a){
	if(xr - xl == 1){
		t[x] = a[xl];
		return;
	}
	build(L, LL, a);
	build(R, RR, a);
	t[x] = t[R] + t[L];
}

void push(int x, int xl, int xr){
	if(d[x]){
		t[L] += d[x] * (M - xl);
		t[R] += d[x] * (xr - M);
		d[L] += d[x];
		d[R] += d[x];
		d[x] = 0;
	}
}
int get(int l, int r, int x, int xl, int xr){
	if(xl >= r or xr <= l) return 0;
	
	if(xl >= l and xr <= r){
		return t[x];
	}
	push(x, xl, xr);
	
	return get(l, r, L, LL) + get(l, r, R, RR);
	
}

void add(int l, int r, int x, int v, int xl, int xr){
	if(xl >= r or xr <= l) return;
	
	if(xl >= l and xr <= r){
		t[x] += v * (xr - xl);
		d[x] = v;
		return;
	}
	push(x, xl, xr);
	
	add(l, r, L, v, LL);
	add(l, r, R, v, RR);
}

void print_TREE(int x, int tab, int mx){
	if(mx <= x) return;
	print_TREE(R, tab + 4, mx);
	for(int i = 0; i < tab; i++){
		cout << "|";
	}
	cout << "( " << t[x] << ", " << " )" << ENDL;
	print_TREE(L, tab + 4, mx);
}

vector<int> p, r;

int get(int a){
	if(a != p[a]){
		p[a] = get(p[a]);
	}
	return p[a];
}

void join(int a, int b){
	a = get(a);
	b = get(b);
	if(a == b){
		return;
	}
	if(r[a] > r[b]) swap(a, b);
	
	p[a] = p[b];
	
	if(r[a] == r[b]){
		r[b]++;
	}
	
}


void solve(){
	int n; cin>>n; vector<int> a(n);
	vector<pair<int, int>> b(n);
	for(int i = 0; i < n; i++)
		cin>>a[i];
	for(int i = 0; i < n; i++) {
		int k; cin>>k;
		b[i].ff = k;
		b[i].ss = i;
	}
	sort(b.begin(), b.end());
	bool red_flag = false;
	if(b[0].ff - a[b[0].ss] < 0)
		red_flag = true;
	for(int i = 1; i < n; i++) {
		if(b[i - 1].ff - a[b[i - 1].ss] > b[i].ff - a[b[i].ss])
			red_flag = true;
		if(b[i].ff - a[b[i].ss] < 0)
			red_flag = true;
	}
	if(red_flag) {
		cout<<-1<<endl;
		return;
	}
	int ans = 0;
	ans = (b[n - 1].ff - a[b[n - 1].ss]);
	cout<<ans<<endl;
}


signed main()
{
	
	goodluck
	
	int T; cin>>T;
	while(T--) {
		solve();
	}
	
	return 0;
}
