#include <bits/stdc++.h>
#define pb push_back
#define ff first
#define ss second
#define goodluck ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define int long long
#define ENDL "\n"
using namespace std;

#define L 2 * x + 1
#define R 2 * x + 2
#define M (xl + xr) / 2
#define LL xl, M
#define RR M, xr

vector<int> t, d;


void build(int x, int xl, int xr, vector<int>& a){
	if(xr - xl == 1){
		t[x] = a[xl];
		return;
	}
	build(L, LL, a);
	build(R, RR, a);
	t[x] = t[R] + t[L];
}

void push(int x, int xl, int xr){
	if(d[x]){
		t[L] += d[x] * (M - xl);
		t[R] += d[x] * (xr - M);
		d[L] += d[x];
		d[R] += d[x];
		d[x] = 0;
	}
}
int get(int l, int r, int x, int xl, int xr){
	if(xl >= r or xr <= l) return 0;
	
	if(xl >= l and xr <= r){
		return t[x];
	}
	push(x, xl, xr);
	
	return get(l, r, L, LL) + get(l, r, R, RR);
	
}

void add(int l, int r, int x, int v, int xl, int xr){
	if(xl >= r or xr <= l) return;
	
	if(xl >= l and xr <= r){
		t[x] += v * (xr - xl);
		d[x] = v;
		return;
	}
	push(x, xl, xr);
	
	add(l, r, L, v, LL);
	add(l, r, R, v, RR);
}

void print_TREE(int x, int tab, int mx){
	if(mx <= x) return;
	print_TREE(R, tab + 4, mx);
	for(int i = 0; i < tab; i++){
		cout << "|";
	}
	cout << "( " << t[x] << ", " << " )" << ENDL;
	print_TREE(L, tab + 4, mx);
}

vector<int> p, r;

int get(int a){
	if(a != p[a]){
		p[a] = get(p[a]);
	}
	return p[a];
}

void join(int a, int b){
	a = get(a);
	b = get(b);
	if(a == b){
		return;
	}
	if(r[a] > r[b]) swap(a, b);
	
	p[a] = p[b];
	
	if(r[a] == r[b]){
		r[b]++;
	}
	
}
vector<vector<int>> g, g2;

vector<int> tp;
vector<int> dp;
vector<int> visited;

void topsort(int from){
	if(visited[from]){
		return;
	}
	visited[from] = 1;
	for(auto it : g[from]){
		topsort(it);
	}
	tp.push_back(from);
}

void topsort2(int from){
	if(visited[from]){
		return;
	}
	visited[from] = 1;
	for(auto it : g2[from]){
		topsort(it);
	}
	tp.push_back(from);
}

void solve(){
	int n, m;
	cin >> n >> m;
	g = vector<vector<int>>(n +1);
    dp = visited = vector<int>(n + 1);
    tp.clear();
    for(int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
		dp[b]++;
    }
//  topsort(1);
    for(int i = 1; i <= n; i++){
        if(!visited[i])
        topsort(i);
    }
//    visited = vector<int>(n + 1);
//    reverse(tp.begin(), tp.end());
//    vector<int> copy = tp;
//    tp.clear();
//    for(auto it : copy){
//        if(!visited[it])
//        topsort(it);
//    }
	int cnt = 0;
	int sz = m % 2 + m /2;
//    if(tp.size() != n){
//        cout << -1 << ENDL;
//        return;
//    }
	for(auto it : tp){
		cnt += dp[it];
	}
	if(cnt + 200 < sz){
		cout << -1 <<ENDL;
		return;
	}
    reverse(tp.begin(), tp.end());
    for(auto it : tp) cout << it << " ";
    cout << ENDL;
}


signed main()
{
	
	goodluck
	int t = 1;
	cin >> t;
	for(int i = 0; i < t; i++)
	solve();
	
	return 0;
}
