#include<bits/stdc++.h>
#define sonic ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define ll long long int
#define pb push_back
#define pf push_front
using namespace std;
const ll MAXV = 1e5 + 50;
const ll INF = 9e18;

void dfs(ll v, ll& t, ll idx, ll& ans, vector<ll>& used, vector<ll>& tin, vector<vector<ll>>& g, vector<ll>& topsort) {
	used[v] = idx;
	tin[v] = t++;
	
	for (auto& u : g[v]) {
		if (used[u] > 0) {
			if (used[u] == idx && tin[u] < tin[v]) {
				ans++;
			}
			
			continue;
		}
		
		dfs(u, t, idx, ans, used, tin, g, topsort);
	}
	
	topsort.push_back(v);
}


void solve() {
	ll n, m;
	cin >> n >> m;
	
	vector<ll> used(n + 1);
	vector<ll> tin(n + 1);
	vector<ll> topsort = {};
	vector<vector<ll>> g(n + 1);

	vector<ll> degree(n + 1);	
	vector<pair<ll, ll>> order = {};
	
	for (ll i = 1; i <= m; i++) {
		ll u, v;
		cin >> u >> v;
		
		g[u].push_back(v);
		degree[v]++;
	}
	
	for (ll i = 1; i <= n; i++) {
		order.push_back({ degree[i], i });
	}
	
	sort(order.begin(), order.end());
	
	ll ans = 0;
	ll idx = 1;
	ll t = 0;
	for (auto& x : order) {
		ll i = x.second;
		
		if (used[i]) continue;
		
		dfs(i, t, idx, ans, used, tin, g, topsort);
		idx++;
	}
	
	reverse(topsort.begin(), topsort.end());
	
	if (ceil((double)m / 2) <= m - ans) {
		for (auto& x : topsort) {
			cout << x << " ";
		}
		cout << endl;	
	}
	else {
		cout << -1 << endl;
	}
	
}

int main() {
	ll t;
	cin >> t;
	
	while (t--) {
		solve();
	}
}

