#include <bits/stdc++.h>

#pragma GCC optimize("Ofast,O3,unroll-loops")
#pragma GCC target("sse,sse2,ssse3,sse4,abm,mmx,avx2,bmi,bmi2,popcnt,lzcnt")

#define ll long long
#define pb push_back
#define f first
#define s second
#define IOS ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
//#define endl '\n'

ll gcd(ll a, ll b){
    return (b) ? gcd(b, a % b) : a;
}

ll binpow(ll x, ll p, ll mod = LLONG_MAX){
    ll ans = 1;
    while(p){
        if(p & 1) ans = (ans * x) % mod;
        x = (x * x ) % mod;
        p >>= 1;
    }
    return ans;
}


using namespace std;

const int  N = 2e5+500;
ll inf = 1e9+7;
vector<int> g[N];
int sz[N];
int used[N];
int in[N];
int dfs(int v,int prev=-1){
    if(used[v]){
        return sz[v];
    }
    used[v]=1;
    for(auto to:g[v]){
        sz[v]+=dfs(to,v);
    }
    sz[v]++;
    return sz[v];
}
void solve(){
    int n,m;
    cin>>n>>m;
    for(int z=1;z<=n;z++){
        g[z].clear();
        used[z]=0;
        sz[z]=0;
        in[z]=0;
    }
    for(int z=0;z<m;z++){
        int u,v;
        cin>>u>>v;
        g[u].push_back(v);
        in[v]++;
    }
    vector<pair<int,int> >cont;
    for(int z=1;z<=n;z++){
        cont.pb({in[z],z});
    }
    sort(cont.begin(),cont.end());
    for(auto x:cont){
        if(!used[x.second]){
            dfs(x.second);
        }
    }
//    for(int z=1;z<=n;z++){
//        if(!used[z]){
//            dfs(z);
//        }
//    }
    vector<pair<int,int> >ans;
    for(int z=1;z<=n;z++){
        ans.push_back({-sz[z],z});
    }
    sort(ans.begin(),ans.end());
    map<int,int>rem;
    for(int z=0;z<(int)ans.size();z++){
        rem[ans[z].second]=z+1;
    }
    int cnt=0;
    for(int z=1;z<=n;z++){
        for(auto x:g[z]){
            cnt+=(rem[z]<rem[x]);
        }
    }
    if(cnt<(m+1)/2){
        reverse(ans.begin(),ans.end());
        for(auto x:ans){
            cout<<x.second<<" ";
        }
        cout<<endl;
        return;
    }
    for(auto x:ans){
        cout<<x.second<<" ";
    }
    cout<<endl;
}
int32_t main(){
    IOS;
    int t=1;
    cin>>t;
    while(t--){
        solve();
    }
}
