#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define f first
#define s second
#define ndl '\n'
#define pb push_back
typedef long long ll;

using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
long long rand(long long l, long long r) {
	return uniform_int_distribution<long long> (l,r)(rng);
}

void solve() {
	int n, m;
	cin >> n >> m;
	
	vector<vector<int>> g(n+1), gg(n+1);
	vector<int> out(n + 1), in(n+1);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		g[v].pb(u);
		gg[u].pb(v);
	}
	
	vector<int> us1(n+1);
	vector<int> ts1;
	function<void(int)> dfs1 = [&](int v) {
		us1[v] = 1;
		for (auto to : gg[v]) {
			if (us1[to]) continue;
			dfs1(to);
		}
		ts1.pb(v);
	};
	
	for (int v = 1; v <= n; ++v) {
		if (!us1[v])
		  dfs1(v);
	}

	reverse(all(ts1));
	
	vector<int> us2(n+1);
	set<int> comp;
	function<void(int)> dfs2 = [&](int v) {
		us2[v] = 1;
		for (auto to : g[v]) {
			if (us2[to]) continue;
			dfs2(to);
		}
		comp.insert(v);
	};
	
	vector<int> us3(n+1);
	function<void(int)> dfs3 = [&](int v) {
		us3[v] = 1;
		for (auto to : g[v]) {
			if (!comp.count(to)) continue;
			out[to]++;
			in[v]++;
			if (us3[to]) continue;
			dfs3(to);
		}
	};
	
	set<pair<int, int>> bad;
	vector<int> used(n + 1);
	for (auto v : ts1) {
		if (us2[v]) continue;
//		cout << v << ": ";
		dfs2(v);
		dfs3(v);
//		for (auto x : comp) cout << x << ' ';
//		cout << '\n';
		set<pair<int, int>> s;	
		for (auto i : comp) {
			s.insert({in[i] - out[i], i});
//			cout << i <<' ' <<in[i] << ' ' << out[i] << '\n';
		}
		
		while (s.size()) {
			auto [x, v] = *s.begin();
//			cout << v << '\n';
			s.erase(s.begin());
			used[v] = 1;
			for (auto to : gg[v]) {
				if (used[to] || comp.count(to) == 0) continue;
				s.erase({in[to] - out[to], to});
				in[to]--;
				s.insert({in[to] - out[to], to});
			}
			for (auto to : g[v]) {
				if (used[to] || comp.count(to) == 0) continue;
				s.erase({in[to] - out[to], to});
				out[to]--;
				s.insert({in[to] - out[to], to});
				bad.insert({to, v});
			}
		}
		
		comp.clear();
//		cout << '\n';
	}
	
//	for (auto [to, v] : bad) cout << to << ' ' << v << '\n';
		
	vector<int> us(n+1);
	vector<int> ts;
	function<void(int)> dfs = [&](int v) {
		us[v] = 1;
		for (auto to : gg[v]) {
			if (us[to]) continue;
			if (bad.count({v, to})) continue;
			dfs(to);
		}
		ts.pb(v);
	};
	
	for (int v = 1; v <= n; ++v) {
		if (!us[v])
		  dfs(v);
	}

	reverse(all(ts));
	
	int k = m - bad.size();
	if (k < (m+1)/2) {
		cout << -1;
	} else {
		for (auto x : ts) cout << x << ' ';
	}
	cout << ndl;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	cin >> tt;
	while(tt--) {
		solve();
	}
}
