#include <iostream>
#include <cstdlib>
#include <bits/stdc++.h>
using namespace std;


void dfs(int v, vector<vector<int>> &m, int n, vector<bool> &seen, int& count, int& countr, string& s) {
	s += v + '0';
   	seen[v] = true;
	for(int i = 1; i < n+1 ; i++) {
		if(m[v][i]) {
			if (seen[i]) {
				countr++;
			} else {
				count++;
				dfs(i, m, n, seen, count, countr, s);
			}
		} 
	}
}

void solve() {

	int n, e;
	cin >> n >> e;

	int count = 0;
	int countr = 0;
	string s = "";

	vector<vector<int>> m(n+1);
	for(int i = 0; i < n+1; i++) {
		vector<int> v1(n+1, 0);
		m[i] = v1;
	}
	for(int i = 0; i < e; i++) {
	   int a, b;
	   cin >> a >> b;
	   m[a][b] = 1;
	}
	vector<bool> seen(n+1, false);
	for (int i = 1; i < n+1; i++) {
		if(!seen[i]) {
			dfs(i, m, n, seen, count, countr, s);
		}
	}
	
	if (countr > count) {
		reverse(s.begin(), s.end());
	}
	
	for (int i = 0; i < s.size(); i++) {
		cout << s[i] << ' ';
	}
	cout << endl;
}


int main () {
	int t;
	cin >> t;
	
	while(t--) solve();
}
