#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define mk make_pair
#define f first
#define s second
#define vt vector 
#define dbg(x) cout << (#x) << ": " << (x) << '\n';
#define en '\n'

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define rev(x) reverse(x.begin(), x.end())
#define sz(x) (int)x.size()

template <class T, class TT> void mineq(T& a, const TT& b){ if(b < a) a = b; }
template <class T, class TT> void maxeq(T& a, const TT& b){ if(b > a) a = b; } 

#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef double ld;
typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<pair<int, int>> vii;
typedef vector<pair<ll, ll>> vll;

const int N = 100;

int n, k;
vt<string> ar;

int gr[N][N];

void solve(){
	cin >> n >> k;
	for(int i = 0;i < n;i++){
		string x;
		cin >> x;
		ar.pb(x);
	}

	for(const auto& s : ar){
		for(int i = 0;i < sz(s);i++){
			int nxt = (i + 1) % sz(s);

			int from = s[i] - 'a';
			int to = s[nxt] - 'a';

			gr[from][to] = 1;
		}
	}

	vi cnt(k, 0);
	for(int from = 0;from < k;++from){
		for(int to = 0;to < k;++to){
			cnt[from] += gr[from][to];
		}
		// cout << "cnt: " << (char)('a' + from) << " : " << cnt[from] << en;
	}

	for(int i = 0;i < k;i++){
		if(cnt[i] == 0){
			cout << (char)('a' + i) << en;
			return;
		}
	}

	for(int from = 0;from < k;++from){
		for(int to = 0;to < k;++to){
			if(gr[from][to] == 0){
				char first = 'a' + from;
				char second = 'a' + to;

				cout << first << second << en;
				return;
			}
		}
	}

	cout << "NO" << en;
}

int main(){
	fast_io;

	int test_cases = 1;
	// cin >> test_cases;
	for(int test_case = 1;test_case <= test_cases;++test_case){
		// cout << "Case #" << test_case << en;
		solve();
	}
}