def run(heights, n):
    prev_dif = heights[0][1] - heights[0][0]
    if prev_dif < 0:
        return -1
    max_dif = prev_dif
    for i in range(1, n):
        cur_dif = heights[i][1] - heights[i][0]
        if cur_dif < prev_dif or cur_dif < 0:
            return -1
        if max_dif < cur_dif:
            max_dif = cur_dif
    
    return max_dif


def main():
    for _ in range(int(input())):
        n = int(input())
        cur = list(map(int, input().split()))
        old = list(map(int, input().split()))

        heights = [[cur[i], old[i]] for i in range(n)]
        heights.sort(key=lambda el: el[1])

        print(run(heights, n))


main()


'''
4
4
3 2 4 2
5 3 6 2
1
10
100000
5
1 2 3 4 5
1 2 3 4 5
3
1 4 6
4 1 8
'''