#include <iostream>
#include <string>
#include <cmath>
#include <vector>
#include <map>
#include <utility>
#include <set>
#include <stack>
#include <iomanip>
#include <algorithm>
#include <queue>
#include <climits>

using namespace std;

int main(){
    ios_base::sync_with_stdio(false);cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    while(t--){
        bool end=false;
        int n; cin>>n;
        int res=0;
        vector<pair<int,int>> ms(n);
        for(int i=0;i<n;i++) {
            cin>>ms[i].second; // new s
        }
        for(int i=0;i<n;i++) {
            cin>>ms[i].first; // old f
        }
        sort(ms.begin(),ms.end());
        for(int i=0;i<n;i++) {
            printf("first:%d, second:%d\n", ms[i].first,ms[i].second);
        }
        for(int i=0;i<n;i++) {
            int diff=ms[i].first-ms[i].second;
            if(diff==0) continue;
            if(diff<0) {
                end=true;
                cout<<-1<<endl;
                break;
            }
            else {
                res+=diff;
                for(int j=i;j<n;j++) {
                    ms[j].first-=diff;
                    if(ms[j].first<ms[j].second) {
                        if(!end) {
                            end=true;
                            cout<<-1<<endl;
                            break;
                        }
                    }
                    if(end) break;
                }
            }
        }
        if(end) continue;
        cout<<res<<endl;
    }
    return 0;
}