#include <bits/stdc++.h>
#define ll long long
#define pb push_back
#define all(v) v.begin(), v.end();

using namespace std;

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<int> out(n + 5, 0), in(n + 5, 0);
    vector<int> g[n + 5], gr[n + 5];
    vector<int> used(n + 5);
    for (int i = 1; i <= m; ++i)
    {
        int u, v;
        cin >> u >> v;

        ++out[u];
        ++in[v];

        g[u].pb(v);
        gr[v].pb(u);
    }

    set<pair<int, int>> st;
    for (int i = 1; i <= n; ++i)
    {
        st.insert({out[i] - in[i], i});
    }

    ll sum = 0;
    vector<int> ans;

    while (st.size())
    {
        auto [val, v] = *st.rbegin();
        st.erase(--st.end());

        ans.pb(v);
        used[v] = 1;
        sum += out[v];

        for (auto to : g[v])
        {
            if (used[to])
                continue;
            st.erase({out[to] - in[to], to});
            --in[to];
            st.insert({out[to] - in[to], to});
        }

        for (auto to : gr[v])
        {
            if (used[to])
                continue;
            st.erase({out[to] - in[to], to});
            --out[to];
            st.insert({out[to] - in[to], to});
        }
    }

    if (sum * 2 < m)
    {
        cout << "-1\n";
        return;
    }

    for (auto x : ans)
        cout << x << " ";
    cout << "\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tt;
    cin >> tt;
    while (tt--)
    {
        solve();
    }

    return 0;
}