#include<bits/stdc++.h>

#define ll long long
#define pb push_back
#define sz(x) (int)((x).size())
#define vi vector<int>
#define pii pair<int,int>
#define all(x) x.begin(), x.end()

using namespace std;

const ll mod = (ll)1e9+7;
const ll inf = (ll)1e18+7;
const int N = (int)2e5 + 100;
const int M = (int)1e7 + 100;
const double eps = 1e-9;
const char nl = '\n';

int n, m;
vi g[N];
int u[N];
vi top;

void dfs(int v) {
    u[v] = 1;
    for(auto to : g[v]) {
        if(!u[to]) {
            dfs(to);
        }
    }
    top.pb(v);
}
int fr[N], to[N];

bool check(vector<int> & v) {
    vi pos(n+1);
    for(int i = 0; i < sz(v); i++) {
        pos[v[i]] = i+1;
    }
    int cnt = 0;
    for(int i = 1; i <= m; i++) {
        if( pos[fr[i]] < pos[to[i]] ) cnt++;
    }
    return (cnt*2 >= m);
}

void solve() {
    cin >> n >> m;
    vi cnt(n+1,0);
    for(int i = 1; i <= m; i++) {
        cin >> fr[i] >> to[i];
        g[fr[i]].pb(to[i]);
        cnt[fr[i]]++;
    }
    vector<pii>v;
    for(int i =1 ; i <= n; i++)
        v.pb({cnt[i], i});
    sort(all(v));
    reverse(all(v));
    for(int i = 0; i < sz(v); i++) {
        int ver = v[i].second;
        if(!u[ver])
            dfs(ver);
    }
    vi x = top;
    reverse(all(x));
    if(check(top)) {
        for(auto i : top)   cout << i << " ";
    }
    else if(check(x)) {
        for(auto i : x)   cout << i << " ";
    }else {
        cout << -1;
    }
  //  for(auto i : top)   cout << i << " ";
    top.clear();
    for(int i = 1; i <=n ; i++)u[i] = 0;
    for(int i = 1; i <= n; i++)g[i].clear();
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int times = 1;
    cin >> times;
    for(int i = 1; i <= times; i++) {
        //cout << "Case " << i << ": ";
        solve();
        cout << nl;
    }
}
