#include<bits/stdc++.h>

using namespace std;

#define ll long long
#define sz(x) (int)size(x)
#define all(x) x.begin(),x.end()
#define fi first
#define se second

const int N = 2e5+7;
const int E9 = 1e9;
const int maxn = (int)1e5 + 7;

struct str {
    int in, out, ver;
};

int tt, n, m, cnt_in[maxn], cnt_out[maxn];

vector <int> g[maxn];
vector <str> v;
vector <int> ans;
bool u[maxn], us[maxn];

bool cmp (str a, str b) {
    if (a.out > b.out) {
        return true;
    }
    if (a.out == b.out && a.in > b.in) {
        return true;
    }
    return false;
}

bool cmp2(int a, int b) {
    if (cnt_out[a] > cnt_out[b]) {
        return true;
    }
    if (cnt_out[a] == cnt_out[b] && cnt_in[a] > cnt_in[b]) {
        return true;
    }
    return false;
}

void dfs1(int v) {
    u[v] = true;
    sort(g[v].begin(), g[v].end(), cmp2);
    for (auto to : g[v]) {
        if (!u[to]) {
            dfs1(to);
        }
    }
    ans.push_back(v);
}

int dfs2(int v)
{
    us[v] = true;
    int sum = 0;
    for (auto to: g[v])
    {
        sum += (ans[v] < ans[to] ? 1 : 0);
        if (!us[to]) sum += dfs2(to);
    }
    return sum;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> tt;
    while (tt--) {
        cin >> n >> m;
        for (int i = 1; i <= m; i++) {
            int x, y;
            cin >> x >> y;
            g[x].push_back(y);
            cnt_out[x]++;
            cnt_in[y]++;
        }
        for (int i = 1; i <= n; i++) {
            v.push_back({cnt_in[i], cnt_out[i], i});
        }
        sort(v.begin(), v.end(), cmp);
        for (int i = 0; i < v.size(); i++) {
            if (!u[v[i].ver]) {
                dfs1(v[i].ver);
            }
        }
        reverse(ans.begin(), ans.end());
        if (dfs2(v[0].ver) >= (m + 1) / 2) {
            for (auto it : ans) {
                cout << it << ' ';
            }
            cout << '\n';
        }
        else {
            cout << "-1\n";
        }
        for (int i = 1; i <= n; i++) {
            u[i] = false;
            us[i] = false;
            cnt_in[i] = 0;
            cnt_out[i] = 0;
            g[i].clear();
        }
        v.clear();
        ans.clear();
    }
}
