#include <bits/stdc++.h>

#define x first
#define y second
#define pb push_back
#define sz(v) (int)v.size()
#define all(v) v.begin(),v.end()

using namespace std;

using ll = long long;

const int N = 1e6 + 123;
int init[N],fin[N];
const int mod = 998244353;

void add(ll &a, ll b) {
    a += b;
    if (a >= mod) a -= mod;
}

ll K[N][3];

ll k(int x, int p, int q) {
    if (p == q) return 0;
    return K[x][abs(p - q)];
}

ll f(int x, int q) {
    if (x == 0) return 0;
    if (init[x] == q) return f(x - 1, q);
    ll ans = 0;
    if (init[x] == 1) {
        if (q == 2) {
            add(ans, f(x - 1, 3));
            add(ans, 1);
            add(ans, k(x - 1, 3, 2));
        } else { // 3
            add(ans, f(x - 1, 3));
            add(ans, 1);
            add(ans, k(x - 1, 3, 1));
            add(ans, 1);
            add(ans, k(x - 1, 1, 3));
        }
    } else if (init[x] == 2) {
        if (q == 1) {
            add(ans, f(x - 1, 3));
            add(ans, 1);
            add(ans, k(x - 1, 3, 1));
        } else {
            add(ans, f(x - 1, 1));
            add(ans, 1);
            add(ans, k(x - 1, 1, 3));
        }
    } else { // 3
        if (q == 2) {
            add(ans, f(x - 1, 1));
            add(ans, 1);
            add(ans, k(x - 1, 1, 2));
        } else { // 1
            add(ans, f(x - 1, 1));
            add(ans, 1);
            add(ans, k(x - 1, 1, 3));
            add(ans, 1);
            add(ans, k(x - 1, 3, 1));
        }
    }
    init[x] = q;
    return ans;
}

ll h(int x, int q) {
    if (x == 0) return 0;
    if (q == fin[x]) return h(x - 1, q);
    ll ans = 0;
    if (q == 1) {
        if (fin[x] == 2) {
            add(ans, k(x - 1, q, 3));
            add(ans, 1);
            add(ans, h(x - 1, 3));
        } else { // 3
            add(ans, k(x - 1, 1, 3));
            add(ans, 1);
            add(ans, k(x - 1, 3, 1));
            add(ans, 1);
            add(ans, h(x - 1, 1));
        }
    } else if (q == 2) {
        if (fin[x] == 1) {
            add(ans, k(x - 1, q, 3));
            add(ans, 1);
            add(ans, h(x - 1, 3));
        } else {
            add(ans, k(x - 1, q, 1));
            add(ans, 1);
            add(ans, h(x - 1, 1));
        }
    } else { // 3
        if (fin[x] == 2) {
            add(ans, k(x - 1, q, 1));
            add(ans, 1);
            add(ans, h(x - 1, 1));
        } else { // 1
            add(ans, k(x - 1, q, 1));
            add(ans, 1);
            add(ans, k(x - 1, 1, 3));
            add(ans, 1);
            add(ans, h(x - 1, 3));
        }
    }
    return ans;
}

ll g(int x) {
    if (x == 0) return 0;
    if (init[x] == fin[x]) return g(x - 1);
    ll ans = 0;
    if (init[x] == 1) {
        if (fin[x] == 2) {
            add(ans, f(x - 1, 3));
            add(ans, 1);
            add(ans, h(x - 1, 3));
        } else { // 3
            add(ans, f(x - 1, 3));
            add(ans, 1);
            add(ans, k(x - 1, 3, 1));
            add(ans, 1);
            add(ans, h(x - 1, 1));
        }
    } else if (init[x] == 2) {
        if (fin[x] == 1) {
            add(ans, f(x - 1, 3));
            add(ans, 1);
            add(ans, h(x - 1, 3));
        } else {
            add(ans, f(x - 1, 1));
            add(ans, 1);
            add(ans, h(x - 1, 1));
        }
    } else { // 3
        if (fin[x] == 2) {
            add(ans, f(x - 1, 1));
            add(ans, 1);
            add(ans, h(x - 1, 1));
        } else { // 1
            add(ans, f(x - 1, 1));
            add(ans, 1);
            add(ans, k(x - 1, 1, 3));
            add(ans, 1);
            add(ans, h(x - 1, 1));
        }
    }
    return ans;
}


void solve() {
    int n;
    cin >> n;
    for (int i = 1 ; i <= n ; ++ i) {
        cin >> init[i];
    }
    for (int i = 1 ; i <= n ; ++ i) {
        cin >> fin[i];
    }
    cout << g(n);
}


int main() {
    ios_base::sync_with_stdio(0), cin.tie(0); cout.tie(0);

    for (int i = 1 ; i < N ; ++ i) {
        int x = i;
        add(K[x][1], K[x - 1][2]);
        add(K[x][1], 1);
        add(K[x][1], K[x - 1][1]);

        add(K[x][2], K[x - 1][2]);
        add(K[x][2], 1);
        add(K[x][2], K[x - 1][2]);
        add(K[x][2], 1);
        add(K[x][2], K[x - 1][2]);
    }
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
        cout << "\n";
    }

    return 0;
}
