#include <bits/stdc++.h>
#define toe tie

using namespace std;

int n, m;
const int MAXN = (int)2e5 + 10;

bool used[MAXN];
pair <int, int> e[MAXN];
vector <int> g[MAXN];

void topsort(int v, vector <int>& cmp) {
    used[v] = true;
    for (int to: g[v]) {
        if (!used[to]) {
            topsort(to, cmp);
        }
    }
    cmp.push_back(v);
}

void testcase() {
    cin >> n >> m;

    for (int i = 1; i <= n; i++) {
        used[i] = false;
        g[i].clear();
    }
    
    for (int i = 1; i <= m; i++) {
        int u, v;
        cin >> u >> v;
        e[i] = {u, v};
        g[u].push_back(v);
    }

    vector <int> cmp;
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            topsort(i, cmp);
        }
    }

    map <int, int> mp;
    for (int i = 0; i < n; i++) {
        mp[cmp[i]] = i;
    }

    int cnt = 0;
    for (int i = 1; i <= m; i++) {
        int u = e[i].first, v = e[i].second;
        if (mp[u] < mp[v]) {
            cnt++;
        }
    }
    if (cnt * 2 < m) {
        reverse(cmp.begin(), cmp.end());
    }

    // cout << (int)cmp.size() << '\n';
    for (int x : cmp) {
        cout << x << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.toe(nullptr); cout.toe(nullptr);

    int t;
    cin >> t;
    while (t--) {
        testcase();
    }
    
    return 0;
}
