#include "bits/stdc++.h"
using namespace std;

void printer(){
    cout << '\n';
}
template<typename T, typename... V>
void printer(T t, V... v){
    cout << t << ' ';
    printer(v...);
}

#ifndef ONLINE_JUDGE
#define deb(x...) cout << #x << " : ";printer(x);
#else
#define deb(x...) ;
#endif
#define all(x) x.begin(),x.end()
#define F first
#define S second
#define pb push_back

typedef long long ll;
typedef pair<int,int> pii;


const ll INF = 1e9 + 7;
const ll N = 5e3 + 12;
int n, A, B;
pair<int,int > p[N]; // suit,suit
vector< vector<int> > hand;

int dp[N][N], vp[N][N]; //suit, i-> needs to be add
void solve(){
    cin >> n >> A >> B;
    for(int i = 1; i <= n; i++){
        cin >> p[i].F >> p[i].S;
    }
    sort(p+1, p + 1 + n);

    hand.clear();
    hand.push_back(vector<int>());
    for(int i = 1; i <= n; i++){
        if(p[i].F != p[i - 1].F){
            hand.push_back(vector<int>{-1});
        }
        hand.back().push_back(p[i].S);
    }

    int m =  hand.size() - 1;
    for(int i = 0; i <= m; i++){
        for(int j = 0; j <= n; j++){
            vp[i][j] = -1e9;
        }
    }
    vp[0][0] = 0;
    for(int i = 1; i <= m; i++){
        for(int j = 1; j < hand[i].size(); j++){
            if(hand[i][j] <= (2 * j - 1)){
                dp[i][j] = dp[i][j - 1];
            }else{
                int dif = (hand[i][j] - (( j - 1 + dp[i][j - 1]) * 2 - 1) + 1 ) / 2 - 1;
                dp[i][j] = dp[i][j - 1] + dif;
            }
        }
    }
    for(int i = 1; i <= m; i++){
        for(int j = 0; j < hand[i].size(); j++){
            int delik = hand[i].size() - j - 1;
            for(int k = 0; k <= n - delik; k++){
                vp[i][k + delik] = max(vp[i][k+delik], vp[i - 1][k] + (delik - dp[i][j]) );
            }
        }
    }

    for(int i = 0; i <= n; i++){
        if(vp[m][i] >= 0){
            cout << i << '\n';
            return;
        }
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);
    int T = 1;
    cin>>T;
    while(T--){
        solve();
    }
}
