#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define pb push_back
#define all(v) v.begin(), v.end()
#define pii pair <int, int>
#define pll pair <ll, ll>
#define fi first
#define se second
#define ndl '\n'

const int N = 2e5 + 9;
const int INF = 1e9 + 9;

vector <int> g[N];
bool was[N];
vector <int> p;

void dfs(int v) {
    if (was[v]) return;
    was[v] = true;
    for (int to: g[v]) {
        if (!was[to]) dfs(to);
    }
    p.pb(v);
}

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 1; i <= m; ++i) {
        int u, v; cin >> u >> v;
        g[u].pb(v);
    }
    for (int i = 1; i <= n; i++)
    {
        if (!was[i])
            dfs(i);
    }
    reverse(all(p));

    for (auto node:p)
        cout << node << " ";
    cout << "\n";
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
