#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define nl '\n'
#define mp make_pair
#define F first 
#define S second
#define in insert
#define sz(x) (int)x.size()
#define pii pair <int, int>
#define pll pair <ll, ll>
#define all(x) x.begin(), x.end()


const int mxn = 2e5 + 123;
const int mnn = 1e3 + 10;
const ll mod = 1e9 + 7;

using namespace std;

int x[mxn], cnt[mxn];
char ch[mxn];

void solve() {
	int n, pos_a;
	cin >> n;
	int num_a = 0, num_b = 0;
	for (int i = 1; i <= n; i++) {
		cin >> x[i] >> cnt[i] >> ch[i];
		if (ch[i] == 'R') { 
			num_a += cnt[i];
			pos_a = i;
		} else { 
			num_b += cnt[i];
		}
	}
	if (num_a == num_b) {
		cout << "Draw 0 0\n";
		return;
	}
	stack<pii> sa, sb;
	int diff = 0;
	for (int i = n; i >= 1; i--){
		if(ch[i] == 'R') {
			int red = cnt[i];
			while(!sb.empty() && red > 0) {
				pii top = sb.top();
				sb.pop();
				if(top.second > red) {
					top.second -= red;
					diff += red * (top.first - x[i]);
					sb.push(top);
				} else {
					red -= top.second;
					diff += top.second * (top.first - x[i]);
				}
			}
			if (red > 0) {
				sa.push(mp(x[i], red));
			}
		} else {
			int blue = cnt[i];
			while(!sa.empty() && blue > 0) {
				pii top = sa.top();
				sa.pop();
				if(top.second > blue) {
					top.second -= blue;
					diff -= blue * (top.first - x[i]);
					sb.push(top);
				} else {
					blue -= top.second;
					diff -= top.second * (top.first - x[i]);
				}
			}
			if (blue > 0) {
				sb.push(mp(x[i], blue));
			}
		}
		if(num_a < num_b && diff < 0) {
			cout << "Draw" << ' ' << pos_a << " +" << nl;
			return ;
		} else if (num_a > num_b && diff > 1) {
			cout << "Draw" << ' ' << pos_a << " +" << nl;
			return ;
		}
	}
	if (num_a < num_b) {
		cout << "Second" << nl;
	} else {
		cout << "First" << ' ' << pos_a << " +" << nl;
	}
}

int main () {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	string path = filesystem::current_path().string();

	if (path == "C:\\Users\\qf\\Documents") {
		freopen("input", "r", stdin);
		freopen("output", "w", stdout);
	}

	int t = 1;
	cin >> t;
	while(t--) {
		solve();
	}
}