#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define nl '\n'
#define mp make_pair
#define F first 
#define S second
#define in insert
#define sz(x) (int)x.size()
#define pii pair <int, int>
#define pll pair <ll, ll>
#define all(x) x.begin(), x.end()


const int mxn = 1e6 + 123;
const int mnn = 1e3 + 10;
const ll mod = 1e9 + 7;
const int N = (int)1e5 + 123;

using namespace std;

int n, m;
int in[N], out[N];
bool used[N];
vector <int> gin[N], gout[N];

void solve() {
	cin >> n >> m;
	for (int i = 1; i <= m; i ++) {
		int v, u;
		cin >> v >> u;
		out[v] ++;
		in[u] ++;
		gin[u].pb (v);
		gout[v].pb (u);
	}
	multiset < pii > ms;

	for (int i = 1; i <= n; i ++) {
		ms.in (mp (in[i] - out[i], i));
	}

	vector <int> ans;
	int k = 0;

	while (sz(ms) > 0) {
		pii o = *ms.begin();
		ms.erase (ms.begin());
		used[o.S] = 1;
		ans.pb (o.S);

		k += -o.F;

		for (auto from : gin[o.S]) {
			if (used[from] == true) continue;

			ms.erase(ms.find (mp (in[from] - out[from], from)));
			out[from] --;
			ms.in (mp (in[from] - out[from], from));
		}

		for (auto to : gout[o.S]) {
			if (used[to] == true) continue;

			ms.erase (ms.find(mp (in[to] - out[to], to)));
			in[to] --;
			ms.in(mp (in[to] - out[to], to));
		}

	}

	if (k >= 0) {
		for (auto it : ans) {
			cout << it << " ";
		}
		cout << nl;
	}
	else {
		cout << -1 << nl;
	}


	for (int i = 1; i <= n; i ++) {
		used[i] = 0;
		in[i] = out[i] = 0;
		gin[i].clear();
		gout[i].clear();
	}
}

int main () {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	string path = filesystem::current_path().string();

	if (path == "C:\\Users\\qf\\Documents") {
		freopen("input", "r", stdin);
		freopen("output", "w", stdout);
	}

	int t = 1;
	cin >> t;
	while(t--) {
		solve();
	}
}