#include <bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
#define ll long long
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define vt vector
#define pr pair
const int N = 1e5 + 5;
const int mod = 998244353;

int mult(int &x, int y) {
    return int(1ll*x*y%mod);
}
int sum(int x, int y) {
    x += y;
    if(x >= mod) {
        x -= mod;
    }
    return x;
}
int sub(int x, int y) {
    x -= y;
    if(x<0) {
        x += mod;
    }
    return x;
}
int binpow(int x, int n) {
    if(n == 0) {
        return 1;
    }
    if(n&1^1) {
        int y = binpow(x, n/2);
        return mult(y, y);
    }
    int y = binpow(x, n-1);
    return mult(y, x);
}

bool check(int x1, int y1, int r1, int x2, int y2, int r2) {
    long long e = 1ll*r1*r1-1ll*x1*x1-1ll*y1*y1;
    long long f = 1ll*x2*x2+1ll*y2*y2-1ll*r2*r2;
    long long c = 2ll*x1*x2+2ll*y1*y2+2ll*r1*r2;
    if(e==f-c) {
        return 1;
    }
    return 0;
}

int n, m, k;
int W;
int dp[101][2][8][(1<<16)];

int tot[101][(1<<16)];

void init() {
    int oo = max(n, m);
    dp[1][(k == 1 && W == 1)][1][0] = 1;
    dp[1][(k == 1 && W == 0)][0][0] = 1;
    int WW = (1<<(k+1));
    for(int len = 1; len < oo; ++len) { // 100
        for(int was = 0; was < 2; ++was) { // 2
            for(int last = 0; last < (1<<k); ++last) { // 8
                for(int mask = 0; mask < (1<<WW); ++mask) { // 2^16
                    //int cur = last;
//                    for(int x = 1; x <= k; ++x) {
//                        cur *= 2;
//                        if(len>x) {
//                            cur += ((last>>(k-x))&1);
//                        }
//                    }
                    for(int pp = 0; pp < 2; ++pp) { // 2
                        int ruc = last*2+pp;
                        int rruc;
                        if(len >= k) {
                            rruc = last;
                            if(rruc&(1<<(k-1))) {
                                rruc ^= (1<<(k-1));
                            }
                            rruc = rruc*2+pp;
                        } else {
                            rruc = last*2+pp;
                        }
                        int was_to = was|(len>=k-1 && rruc == W);
                        int mask_to = mask;
                        if(len>=k) {
                            mask_to |= (1<<ruc);
                        }
                        dp[len+1][was_to][rruc][mask_to] = sum(dp[len+1][was_to][rruc][mask_to], dp[len][was][last][mask]);
                    }
                }
            }
        }
    }
    for(int len = 1; len <= oo; ++len) {
        for(int mask = 0; mask < (1<<WW); ++mask) {
            for(int last = 0; last < (1<<k); ++last) {
                tot[len][mask] = sum(tot[len][mask], dp[len][1][last][mask]);
            }
        }
    }
}

int calc() {
    int ans = 0;
    int len = (1<<(k+1));
    for(int mask = 0; mask < (1<<len); ++mask) {
        int can = (((1<<len)-1)^mask);
        for(int sub = can; ; sub = (sub-1)&can) {
            assert((sub&mask) == 0);
            ans = sum(ans, mult(tot[n][mask], tot[m][sub]));
            if(sub == 0) {
                break;
            }
        }
    }
    return ans;
}

void solve() {
    cin >> n >> m >> k;
    string w;
    cin >> w;
    for(int i = 0; i < k; ++i) {
        W = W*2+(w[i] - 48);
    }
    init();
    cout << calc();
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}
