from math import fabs
from functools import lru_cache
test_count = int(input())

@lru_cache
def calc(test_count):
    for _ in range(test_count):
        n = int(input())
        pairs = 0
        matrix = []
        for _ in range(n):
            x, y, r = list(map(int, input().split()))
            if r != 0:
                matrix.append((x,y,r))
        
        for i in range(len(matrix)):
            (xi, yi, ri) = matrix[i]
            for j in range(i, len(matrix)):
                (xj, yj, rj) = matrix[j]
                
                if (xi == 0 and xj == 0 and fabs(yi - yj) == ri + rj) or (yi == 0 and yj == 0 and fabs(xi - xj) == ri + rj): 
                    pairs += 1
                else:
                    if (ri+rj)**2 == (fabs(xi - xj)**2 + fabs(yi - yj)**2):
                        pairs += 1
        
        print(pairs)

calc(test_count)