#include <bits/stdc++.h>
using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
#define  ordered_set tree<int, null_type, less<int>,rb_tree_tag,tree_order_statistics_node_update>
#define F first
#define S second
#define sz(x) (int)x.size()
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define NFS ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

typedef long long ll;
const int N = 1e6 + 7;
const int MOD = 998244353;

int n, m;
bool used[N];
vector<int> g[N];
vector<int> res;

void dfs(int v) {
	used[v] = true;
	for(auto to : g[v]) {
		if (!used[to]) {
			dfs(to);
		}
	}
	res.pb(v);	
}


void solve() {
	cin >> n >> m;
	vector<int> in(n + 3), out(n + 3);
	for(int i = 1; i <= m; ++i) {
		int x, y;
		cin >> x >> y;
		g[x].pb(y);
		in[y]++;
		out[x]++;
	}
	
	vector<pair<int,int>> ord;
	for(int i = 1; i <= n; ++i) {
		int s = out[i] - in[i];
		ord.pb({s, i});
	}
	
	
	sort(all(ord));
	reverse(all(ord));
	for(auto [cnt, v] : ord) {
		if (!used[v]) {
			dfs(v);
		}
	}
	
	reverse(all(res));
	for(auto it : res) {
		cout << it << ' ';
	} cout << '\n';
	
	for(int i = 0; i <= n; ++i) {
		used[i] = false;
		g[i].clear();
	}
	res.clear();
}

int main() {
	NFS;
	int test = 1;
	cin >> test;
	while(test--) {
		solve();
	}
}
/*
1
5 14
1 2
2 3
3 4
4 5
5 4
5 3
5 2
5 1
4 3
4 2
4 1
3 2
3 1
2 1
*/
