import java.util.*;

public class A {
    public static void main(String[] args) {
        Scanner scan = new Scanner(System.in);
        int t = scan.nextInt();

        while (t-- > 0) {
            int n = scan.nextInt();
            long A = scan.nextLong();
            long B = scan.nextLong();

            long[] a = new long[n];
            long[] b = new long[n];

            for (int i = 0; i < n; i++) {
                a[i] = scan.nextLong();
                b[i] = scan.nextLong();
            }

            long l = 0, r = n, ans = n;
            while (l <= r) {
                Map<Long, List<Long>> card = new HashMap<>();
                for (int i = 0; i < n; i++) {
                    if (!card.containsKey( a[i] )) {
                        card.put(a[i], new ArrayList<>());
                    }
                    card.get( a[i] ).add( b[i] );
                }
                for (List<Long> val : card.values()) {
                    Collections.sort(val);
                }

                Map<Long, PriorityQueue<Long>> map = new HashMap<>();
                for (long suit : card.keySet()) {
                    PriorityQueue<Long> pq = new PriorityQueue<>(Collections.reverseOrder());
                    List<Long> list = card.get(suit);
                    for (int i = 0; i < list.size(); i++) {
                        long bi = list.get(i);
                        if (bi / 2 - i > 0) pq.add(bi / 2 - i);
                    }
                    map.put(suit, pq);
                }

                PriorityQueue<Long> pq = new PriorityQueue<>((first, second) -> {
                    long FIRST = map.get(first).peek(), SECOND =  map.get(second).peek();
                    return Long.compare(SECOND, FIRST);
                });
                for (long suit : map.keySet()) {
                    if (map.get(suit).isEmpty()) continue;
                    pq.add(suit);
                }

                long mid = (l + r) / 2, time = mid;
                while (time-- > 0) {
                    if (pq.isEmpty()) break;
                    long suit = pq.poll();
                    map.get(suit).poll();
                    if (map.get(suit).isEmpty()) continue;
                    pq.add(suit);
                }

                long count = 0;
                for (long suit : map.keySet()) {
                    if (map.get(suit).isEmpty()) continue;
                    long max = 0;
                    for (long x : map.get(suit)) {
                        max = Math.max(x, max);
                    }
                    count += max;
                }

                if (count <= mid) {
                    ans = mid;
                    r = mid - 1;
                } else {
                    l = mid + 1;
                }
            }

            System.out.println(ans);
        }
    }
}