#include <bits/stdc++.h>
using namespace std;
#define ll long long

int const N = 2e5 + 500;

vector<int> g[N];
bool visited[N];

vector<int> topSort;
bool inside[N];

void dfs(int x){
	visited[x] = true;
	for(int to : g[x]){
		if(!visited[to]){
			dfs(to);
		}else{
			if(!inside[to]){
				topSort.push_back(to);
				inside[to] = true;
			}
		}
	}
	if(!inside[x])
		topSort.push_back(x);
	inside[x] = true;
}

void solve(string team){
	int n, m;
	cin >> n >> m;
	
	while(m--){
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
	}
	
	for(int i = 1; i <= n; i++){
		if(!visited[i]){
			dfs(i);
		}
	}
	
	reverse(topSort.begin(), topSort.end());
	for(int x : topSort){
		cout << x << " ";
	}
	
}

int main(){
	ios_base::sync_with_stdio();
	cin.tie(NULL);
	cout.tie(NULL);
	
	int t;
	cin >> t;
	while(t--){
			solve("zero");
	}

	return 0;
}
