#include <bits/stdc++.h> 

using namespace std;

void solve() {
	int n;
	cin >> n;
	vector<pair<long long, long long>> p(n);
	for (int i = 0; i < n; i++) {
		cin >> p[i].first;
	}
	for (int i = 0; i < n; i++) {
		cin >> p[i].second;
	}
		
	sort(p.begin(), p.end(), [&](auto x, auto y){
		if (x.second == y.second) return x.first < y.first;
		return x.second < y.second;
	});

	long long used = 0;
	for (int i = 0; i < n; i++) {
		long long cur = p[i].second - used;
		if (cur < p[i].first) {
			cout << "-1\n";
			return;
		}
		used += cur - p[i].first;
		
	}
	
	cout << used << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
	
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
    return 0;
}
