#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define fi first
#define se second
#define pb push_back
#define vi vector<int>
#define pii pair<int,int>
typedef long long ll;

using namespace std;
using namespace __gnu_pbds;
typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

void solve() {
    int n;
    cin >> n;
    int p[n], h[n];
    vector<pair<int,int>> v(n), w(n);
    for(int i = 0; i < n; ++i) cin >> h[i];
    for(int i = 0; i < n; ++i) {
        cin >> p[i];
        v[i] = {p[i], h[i]};
        w[i] = {h[i], p[i]};
        if(p[i] < h[i]) {
            cout << "-1\n";
            return;
        }
    }


    sort(v.begin(), v.end());
    sort(w.begin(), w.end());
    int cur = 0;
    for(int i = 0; i < v.size(); ++i) {
        int x = v[i].first, y = v[i].second;
        //cout << x << ' ' << y << ' ' << cur << '\n';
        x -= cur;
        if(x < y) {
            cout << "-1\n";
            return;
        }
        cur += (x - y);
    }

    for(int i = 1; i < w.size(); ++i) {
        //cout << w[i].second << " " << w[i-1].second;
        if(w[i].second < w[i-1].second) {
            cout << "-1\n";
            return;
        }
    }

    cout << v[n-1].first - v[n-1].second << "\n";
}
/*
1
4
6 5 4 7
16 18 7 17
*/

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}
