import java.util.*;

public class Main {
    private static Scanner sc = new Scanner(System.in);

    public static void main(String[] args) {
        //int t = 1;
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            solve();
        }
    }

    static void solve() {
        int n = sc.nextInt();
        int[] h = new int[n];
        int[] p = new int[n];
        int[][] dif = new int[n][2];
        for (int i = 0; i < n; i++) {
            h[i] = sc.nextInt();
        }
        for (int i = 0; i < n; i++) {
            p[i] = sc.nextInt();
        }
        int curr;
        Map<Integer, Integer> map = new TreeMap<>();
        for (int i = 0; i < n; i++) {
            curr = p[i] - h[i];
            if (curr < 0) {
                System.out.println(-1);
                return;
            }
            dif[i][0] = h[i];
            dif[i][1] = curr;
            map.put(h[i], Math.max(map.getOrDefault(h[i], 0), curr));
        }
        int max = Integer.MIN_VALUE;
        for (int key : map.keySet()) {
            if (map.get(key) < max) {
                System.out.println(-1);
                return;
            }
            max = Math.max(max, map.get(key));
        }
        System.out.println(max);
    }
}