import java.util.*;

public class Main {
    private static Scanner sc = new Scanner(System.in);

    public static void main(String[] args) {
        //int t = 1;
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            solve();
        }
    }

    static void solve() {
        int n = sc.nextInt();
        long[] h = new long[n];
        long[] p = new long[n];
        for (int i = 0; i < n; i++) {
            h[i] = sc.nextLong();
        }
        for (int i = 0; i < n; i++) {
            p[i] = sc.nextLong();
        }
        long curr;
        Map<Long, Long> map = new TreeMap<>();
        for (int i = 0; i < n; i++) {
            curr = p[i] - h[i];
            if (curr < 0) {
                System.out.println(-1);
                return;
            }
            map.put(h[i], Math.max(map.getOrDefault(h[i], 0L), curr));
        }
        long max = Long.MIN_VALUE;
        for (long key : map.keySet()) {
            max = Math.max(max, map.get(key));
        }
        System.out.println(max);
    }
}