import java.util.*;

public class Main {
    private static Scanner sc = new Scanner(System.in);

    public static void main(String[] args) {
        //int t = 1;
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            solve();
        }
    }

    static void solve() {
        int n = sc.nextInt();
        int[][] arr = new int[n][2];
        for (int i = 0; i < n; i++) {
            arr[i][0] = sc.nextInt();
        }
        for (int i = 0; i < n; i++) {
            arr[i][1] = sc.nextInt();
        }
        int max = Integer.MIN_VALUE;
        Arrays.sort(arr, (x, y) -> (x[1] - y[1]));
        for (int i = 0; i < n; i++) {
            if(arr[i][1] < arr[i][0]){
                System.out.println(-1);
                return;
            }
            if(max > arr[i][1] - arr[i][0]){
                System.out.println(-1);
                return;
            }
            max = Math.max(max, arr[i][1] - arr[i][0]);
        }
        System.out.println(max);
    }
}