#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define pb(x) push_back(x)
#define all(x) (x.begin(), x.end())
#define rall(x) (x.rbegin(), x.rend())

struct Pair {
  int x; int y;
};

bool comp(const Pair& x, const Pair& y) {
  return x.y < y.y;
}

void solve() {
  int n; cin >> n;

  vector<int> h(n), p(n);
  vector<Pair> v(n);
  for (int i = 0 ; i < n ; i++) {
    cin >> h[i]; v[i].x = h[i];
  }

  for (int i = 0 ; i < n ; i++) {
    cin >> p[i]; v[i].y = p[i];
  }

  sort(v.begin(), v.end(), comp);


  for (int i = 0 ; i < n ; i++) {
    if (h[i] <= p[i]) continue;
    cout << "-1" << endl;
    return;
  }



  map<int, int> m;

  for (int i = 0 ; i < n ; i++) {
    if (m[p[i]] != 0) {
      if (m[p[i]] != h[i]) {
        cout << "-1" << endl;
        return;
      }
    }
    m[p[i]] = h[i];
  }


  int prev = v[0].x;
  for (int i = 1 ; i < n ; i++) {
    if (prev > v[i].x) {
      cout << "-1" << endl;
      return;
    }
    prev = v[i].x;
  }

  int res = 0;
  for (int i = 0 ; i < n ; i++) {
    res = max(res, p[i] - h[i]);
  }

  cout << res << endl;
}

int main() {
  int t = 1; cin >> t;
  ios_base::sync_with_stdio(false);
  cin.tie(NULL); cout.tie(NULL);
  while (t--) {
    solve();
  }
}
