/*

Men janbasam lapyldap,
Sen janbasan lapyldap,
Ol janbasa lapyldap,
Kimder janar lapyldap?

*/

#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define all(x) (x).begin(),(x).end()

using namespace std;

const int N = (int)1e5 + 3, M = (int)1e6 + 7, SM = (int)1e3 + 5;
const int MOD = (int)1e9 + 7, INF = (int)1e18 + 9;

vector<vector<int>> adj, rev;
vector<int> u, d, ans;
int n, m, flag = -1;

void dfs(int v) {
    u[v] = 1;
    if(d[v] == -1) d[v] = 0;
    ans.pb(v);
    for(auto to : adj[v]) {
        if(!u[to]) {
            d[to] = d[v] + 1;
            dfs(to);
        }
    }
    if(d[v] >= (m + 1) / 2) {
        flag = 1;
    }
}

void solve() {
    cin >> n >> m;

    adj = rev = vector<vector<int>>(n+1);
    u = vector<int>(n+1);
    d = vector<int>(n+1, -1);
    for(int i = 0; i < m; i++) {
        int x, y; cin >> x >> y;
        adj[x].pb(y);
        rev[y].pb(x);
    }

    for(int i = 1; i <= n; i++) {
        if(!u[i]) {
            dfs(i);
        }
    }

    if(flag == 1) {
        for(auto it : ans) {
            cout << it << " ";
        }
        cout << "\n";
    }
    else {
        reverse(all(ans));
        for(auto it : ans) {
            cout << it << " ";
        }
        cout << "\n";
    }

    flag = -1;
    ans.clear();
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int tests = 1;
    cin >> tests;

    while(tests--) {
        solve();
    }

    return 0;
}
