
import java.time.LocalDateTime;
import java.util.*;
public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        Integer totalAlarms = scanner.nextInt();
        StringBuilder alarms = new StringBuilder();
        for(int i=0;i<=totalAlarms;i++){
            alarms.append(scanner.nextLine()).append("\n");
        }
        String[] allAlarms = alarms.toString().split("\n");

        for(int i=0;i<=allAlarms.length-3;i++){
            int alarm = convertToMinute(allAlarms[i+1]);
            //разница между тремя будильниками меньше 10 минут
            if(i<allAlarms.length-3 && convertToMinute(allAlarms[i+3]) - alarm < 10 ){
                System.out.println(0);
                break;
            }
            if(i<allAlarms.length-3 && convertToMinute(allAlarms[i+3]) - alarm == 20 ){
                System.out.println(1);
                break;
            }
            if(i<allAlarms.length-3 && convertToMinute(allAlarms[i+3]) - alarm > 20 ){
                System.out.println(2);
                break;
            }
        }
    }

    private static int convertToMinute(String alarm){
        String[] times = alarm.split(":");
        int minute = Integer.parseInt(times[1]);
        int hourConvertedToMinute = Integer.parseInt(times[0]) * 60;
        return minute + hourConvertedToMinute;
    }

}
