
import java.time.LocalDateTime;
import java.util.*;
public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int totalAlarms = scanner.nextInt();
        StringBuilder alarms = new StringBuilder();
        for(int i=0;i<=totalAlarms;i++){
            alarms.append(scanner.nextLine()).append("\n");
        }
        String[] allAlarms = alarms.toString().split("\n");
        if(totalAlarms == 1) {
            System.out.println(0);
        }
        if(totalAlarms == 2) {
            if(convertToMinute(allAlarms[2]) - convertToMinute(allAlarms[1]) <= 10){
                System.out.println(1);
            } else if (convertToMinute(allAlarms[2]) - convertToMinute(allAlarms[1]) > 10) {
                System.out.println(2);
            }
        } else {
            for(int i=0;i<=allAlarms.length-1;i++){
                int alarm = convertToMinute(allAlarms[i+1]);
                //разница между тремя будильниками меньше 10 минут
                int cursor1 = i+1;
                int cursor2 = i+3;
                boolean isFinished = false;
                while(cursor2 <= allAlarms.length-1 && cursor1 < allAlarms.length && cursor1 < cursor2+2){
                    if(convertToMinute(allAlarms[cursor2]) - convertToMinute(allAlarms[cursor1]) < 10){
                        System.out.println(0);
                        isFinished=true;
                        break;
                    }
                    cursor1++;
                    cursor2++;
                }
                if(isFinished){
                    break;
                }
                if(i<allAlarms.length-3 && convertToMinute(allAlarms[i+3]) - alarm > 20){
                    System.out.println(2);
                    break;
                }
            }
        }
    }

    private static int convertToMinute(String alarm){
        String[] times = alarm.split(":");
        int minute = Integer.parseInt(times[1]);
        int hourConvertedToMinute = Integer.parseInt(times[0]) * 60;
        return minute + hourConvertedToMinute;
    }

}
