#include <iostream>
#include <algorithm>
#include <cmath>

#define ll long long
#define pb push_back
#define sz(x) (int)((x).size())
#define vi vector<int>
#define pii pair<int,int>
#define all(x) x.begin(), x.end()

using namespace std;

const ll mod = (ll)1e9 + 7;
const ll inf = (ll)1e18 + 7;
const int N = (int)2e5 + 100;
const int M = (int)1e7 + 100;
const double eps = 1e-9;
const char nl = '\n';

int n;
int a[N], b[N];
int summ=0;

int solve() {
	bool bIsBigger = true;
	int side;
	int n;
	cin >> n;
	if (n>10000)
	{
		throw exception("wrong value");
	}
	summ += n;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		if (1>a[i] || a[i] >1000000)
		{
			throw exception("wrong value");
		}
		summ += a[i];
		if (1>summ || summ >1000000)
		{
			throw exception("wrong value");
		}
	}
	int mx = 0;
	for (int i = 1; i <= n; i++) {
		int t;
		cin >> b[i];
		if (1 > b[i] || b[i] > 1000000)
		{
			throw exception("wrong value");
		}
		summ += b[i];
		if (1 > summ || summ > 100000)
		{
			throw exception("wrong value");
		}
		t = bIsBigger?b[i] - a[i]: a[i] - b[i];
		if (t<0 && i==0)
		{
			bIsBigger = false;
		}
		else if (t < 0 && i != 0)
		{
			return -1;
		}
		if (mx<t)
		{
			mx = t;
		}
	}
	return mx;
}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int times = 1;
	cin >> times;
	if (times > 1000)
	{
		throw exception("wrong value");
	}
	summ += times;
	int output[10000];
	for (int i = 1; i <= times; i++) {
		//cout << "Case " << i << ": ";
		int result = solve();
		cout<< result <<endl;
		summ += result;
		if (1 > summ || summ > 100000)
		{
			throw exception("wrong value");
		}
	}
	return 0;
}
