#include<bits/stdc++.h>
using namespace std;
const int N = 1e5 + 5;
int n, m, a[N], b[N];
vector<int> g[N];
bool used[N];
int pos[N];
vector<int> topsort;
void dfs(int v){
    used[v] = true;
    for(auto to : g[v]){
        if(!used[to]) dfs(to);
    }
    topsort.push_back(v);
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while(t--){
        cin >> n >> m;
        for(int i = 1; i <= n; i++){
            g[i].clear();
            used[i] = false;
        }
        for(int i = 1; i <= m; i++){
            cin >> a[i] >> b[i];
            g[a[i]].push_back(b[i]);
        }
        topsort.clear();
        for(int i = 1; i <= n; i++){
            if(!used[i]) dfs(i);
        }
        reverse(topsort.begin(), topsort.end());
        int idx = 1;
        for(auto to : topsort){
            pos[to] = idx++;
        }
        int cnt = 0;
        for(int i = 1; i <= m; i++){
            if(pos[a[i]] <= pos[b[i]]) cnt++;
        }
        if(cnt >= (m+1)/2){
            for(auto to : topsort){
                cout << to << ' ';
            }
            cout << '\n';
        }else{
            cout << -1 << '\n';
        }
    }
}
