def solve():
    t = int(input())  
    results = []
    
    for _ in range(t):
        n = int(input())  
        h = list(map(int, input().split()))  
        p = list(map(int, input().split()))  

        diff = [p[i] - h[i] for i in range(n)]  
        
        if any(d < 0 for d in diff):
            results.append(-1)
            continue
        
        years = 0  
        current_max = 0  
        
        for d in diff:
            if d > current_max:
                years += d - current_max
                current_max = d
        
        results.append(years)
    
    for result in results:
        print(result)

solve()
