import sys
input = sys.stdin.read

def main():
    data = input().split()
    t = int(data[0])
    idx = 1
    results = []
    
    for _ in range(t):
        n = int(data[idx])
        idx += 1
        a = list(map(int, data[idx:idx + n]))
        idx += n
        b = list(map(int, data[idx:idx + n]))
        idx += n
        
        valid = True
        max_years = 0
        
        for i in range(n):
            if b[i] < a[i]:
                valid = False
                break
            max_years = max(max_years, b[i] - a[i])
        
        if valid:
            results.append(str(max_years))
        else:
            results.append("-1")
    
    sys.stdout.write("\n".join(results) + "\n")

if __name__ == "__main__":
    main()
