def solve():
    n, e = map(int, input().split())
    keys = [input().strip() for _ in range(n)]


    reachable_letters = set(keys[0])
    visited_keys = set()
    changes = True
    

    while changes:
        changes = False
        for idx, key in enumerate(keys):
            if idx in visited_keys:
                continue
            if any(ch in reachable_letters for ch in key):
                reachable_letters.update(key)
                visited_keys.add(idx)
                changes = True
                

    alphabet = 'abcdefghijklmnopqrstuvwxyz'
    missing_letters = [ch for ch in alphabet if ch not in reachable_letters]

    if len(missing_letters) >= e:

        print(missing_letters[e-1])
    else:
        min_reachable_letter = min(reachable_letters)
        total_count = sum(key.count(min_reachable_letter) for key in keys)
        if total_count >= e:
            print(min_reachable_letter * e)
        else:
            print("No")

            
solve()
      
                 
