def minimum_bricks(l, h):
    # Calculate the number of 1x3 bricks needed for each row
    # Then multiply by h (height of the wall)
    
    # Calculate how many 1x3 bricks are needed per row
    # This is the minimum number required to make the length work with no seam alignment issues
    num_1x3_per_row = (l + 2) // 3  # Ceiling division to cover the length
    return num_1x3_per_row * h  # Multiply by height for the total number of 1x3 bricks

# Input
l, h = map(int, input().split())

# Output
print(minimum_bricks(l, h))
