def minimum_bricks(l, h):
    # To ensure a solid wall, we alternate seam placement.
    # Calculate the minimum number of 1x3 bricks per row
    row_1x3_count = 0
    
    # Simulate a single row and calculate the minimum 1x3 usage
    length_remaining = l
    while length_remaining > 0:
        if length_remaining >= 3:
            row_1x3_count += 1
            length_remaining -= 3
        else:
            length_remaining -= 2  # Fill the rest with 1x2 bricks
    
    # Multiply by the height of the wall (same pattern repeats for all rows)
    total_1x3_bricks = row_1x3_count * h
    return total_1x3_bricks

# Input
l, h = map(int, input().split())

# Output
print(minimum_bricks(l, h))
