#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second 
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define make_unique(x) sort(all(x)), x.erase(unique(all(x)), x.end())

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 Rng(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const int N = 1e5 + 200;
const int M = 1e6;
const int inf = 2e9 + 3;
const ll INF = 1e18;

const int mod = 998244353;

int add(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}

int T;
int n;
int x[N], y[N];
int dp[N][4][4], was[N][4][4];

int go(int k, int a, int b) {
    if (k == 0) return 0;
    if (was[k][a][b] == 1) return dp[k][a][b];
    was[k][a][b] = 1;
    if (a == b) return dp[k][a][b] = 0;
    if (a == 1 && b == 2) {
        return dp[k][a][b] = add(go(k - 1, 1, 3), add(1, go(k - 1, 3, 2)));
    }
    if (a == 2 && b == 3) {
        return dp[k][a][b] = add(go(k - 1, 2, 1), add(1, go(k - 1, 1, 3)));
    }
    if (a == 2 && b == 1) {
        return dp[k][a][b] = add(go(k - 1, 2, 3), add(1, go(k - 1, 3, 1)));
    }
    if (a == 3 && b == 2) {
        return dp[k][a][b] = add(go(k - 1, 3, 1), add(1, go(k - 1, 1, 2)));
    }
    if (a == 1 && b == 3) {
        return dp[k][a][b] = add(go(k - 1, 1, 3), add(1, add(go(k - 1, 3, 1), add(1, go(k - 1, 1, 3)))));
    }
    if (a == 3 && b == 1) {
        return dp[k][a][b] = add(go(k - 1, 3, 1), add(1, add(go(k - 1, 1, 3), add(1, go(k - 1, 3, 1)))));
    }
}

int Move(int k, int r) {
    if (k == 0) return 0;
    if (x[k] == r) {
        return Move(k - 1, r);
    }
    if (x[k] == 1 && r == 3) {
        int ans = Move(k - 1, 3);
        ans = add(ans, 1);
        ans = add(ans, go(k - 1, 3, 1));
        ans = add(ans, 1);
        ans = add(ans, go(k - 1, 1, 3));
        return ans;
    }
    if (x[k] == 2 && r == 3) {
        int ans = Move(k - 1, 1);
        ans = add(ans, 1);
        ans = add(ans, go(k - 1, 1, 3));
        return ans;
    }
    if (x[k] == 3 && r == 1) {
        int ans = Move(k - 1, 1);
        ans = add(ans, 1);
        ans = add(ans, go(k - 1, 1, 3));
        ans = add(ans, 1);
        ans = add(ans, go(k - 1, 3, 1));
        return ans;
    }
    if (x[k] == 2 && r == 1) {
        int ans = Move(k - 1, 3);
        ans = add(ans, 1);
        ans = add(ans, go(k - 1, 3, 1));
        return ans;
    }
    if (x[k] == 1 && r == 2) {
        int ans = Move(k - 1, 3);
        ans = add(ans, 1);
        ans = add(ans, go(k - 1, 3, 2));
        return ans;
    }
    if (x[k] == 3 && r == 2) {
        int ans = Move(k - 1, 1);
        ans = add(ans, 1);
        ans = add(ans, go(k - 1, 1, 2));
        return ans;
    }
}

void solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> x[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> y[i];
    }
    int pos = 0;
    while (n >= 1 && x[n] == y[n]) n--;
    int ans = 0;
    if (x[n] == 1 && y[n] == 2) {
        ans = add(ans, Move(n - 1, 3));
        ans = add(ans, 1);
        for (int i = 1; i < n; ++i) x[i] = 3;
        pos = 3;
    }
    if (x[n] == 2 && y[n] == 3) {
        ans = add(ans, Move(n - 1, 1));
        ans = add(ans, 1);
        for (int i = 1; i < n; ++i) x[i] = 1;
        pos = 1;
    }
    if (x[n] == 2 && y[n] == 1) {
        ans = add(ans, Move(n - 1, 3));
        ans = add(ans, 1);
        for (int i = 1; i < n; ++i) x[i] = 3;
        pos = 3;
    }
    if (x[n] == 3 && y[n] == 2) {
        ans = add(ans, Move(n - 1, 1));
        ans = add(ans, 1);
        for (int i = 1; i < n; ++i) x[i] = 1;
        pos = 1;
    }
    if (x[n] == 1 && y[n] == 3) {
        ans = add(ans, Move(n - 1, 3));
        ans = add(ans, 1);
        ans = add(ans, go(n - 1, 3, 1));
        ans = add(ans, 1);
        for (int i = 1; i < n; ++i) x[i] = 1;
        pos = 1;
    }
    if (x[n] == 3 && y[n] == 1) {
        ans = add(ans, Move(n - 1, 1));
        ans = add(ans, 1);
        ans = add(ans, go(n - 1, 1, 3));
        ans = add(ans, 1);
        for (int i = 1; i < n; ++i) x[i] = 3;
        pos = 3;
    }
    n--;
    for (; n >= 1; --n) {
        if (pos == y[n]) continue;
        x[n] = pos;
        if (x[n] == 1 && y[n] == 2) {
            ans = add(ans, go(n - 1, 1, 3));
            ans = add(ans, 1);
            pos = 3;
        }
        if (x[n] == 2 && y[n] == 3) {
            ans = add(ans, go(n - 1, 2, 1));
            ans = add(ans, 1);
            pos = 1;
        }
        if (x[n] == 2 && y[n] == 1) {
            ans = add(ans, go(n - 1, 2, 3));
            ans = add(ans, 1);
            pos = 3;
        }
        if (x[n] == 3 && y[n] == 2) {
            ans = add(ans, go(n - 1, 3, 1));
            ans = add(ans, 1);
            pos = 1;
        }
        if (x[n] == 1 && y[n] == 3) {
            ans = add(ans, go(n - 1, 1, 3));
            ans = add(ans, 1);
            ans = add(ans, go(n - 1, 3, 1));
            ans = add(ans, 1);
            pos = 1;
        }
        if (x[n] == 3 && y[n] == 1) {
            ans = add(ans, go(n - 1, 3, 1));
            ans = add(ans, 1);
            ans = add(ans, go(n - 1, 1, 3));
            ans = add(ans, 1);
            pos = 3;
        }
    }
    cout << ans << '\n';
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> T;
    while (T--) solve();
}
