#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second 
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define make_unique(x) sort(all(x)), x.erase(unique(all(x)), x.end())

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 Rng(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const int N = 1e6 + 200;
const int M = 1e6;
const int inf = 2e9 + 3;
const ll INF = 1e18;

int T;
int n;
int h[N], w[N];
int saw[N];
pair<int, int> p[N];

void solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> h[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> w[i];
        p[i] = {w[i], h[i]};
    }
    for (int i = 1; i <= n; ++i) {
        if (w[i] < h[i]) {
            cout << -1 << '\n';
            return;
        }
    }
    sort(p + 1, p + n + 1);
    reverse(p + 1, p + n + 1);
    for (int i = 1; i <= n; ++i) {
        if (i > 1 && p[i].F == p[i - 1].F && p[i].S != p[i - 1].S) {
            cout << -1 << '\n';
            return;
        }
        if (i > 1) {
            if (p[i - 1].S < p[i].S) {
                cout << -1 << '\n';
                return;
            }
            if (p[i - 1].F - p[i - 1].S < p[i].F - p[i].S) {
                cout << -1 << '\n';
                return;
            }
        }
    }
    cout << p[1].F - p[1].S << '\n';

}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> T;
    while (T--) solve();
}
