#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second 
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define make_unique(x) sort(all(x)), x.erase(unique(all(x)), x.end())

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 Rng(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const int N = 1e6 + 200;
const int M = 1e6;
const int inf = 2e9 + 3;
const ll INF = 1e18;

const int mod = 998244353;

int mul(int a, int b) {
    return a * 1ll * b % mod;
}

int add(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}

int sub(int a, int b) {
    if (a - b < 0) return a - b + mod;
    return a - b;
}

int n, m, k;
string w;
int dp[2][100][1<<3];
int ok[1<<4];

int count(int n, vector<int> can, string need) {
    int take = 0;
    reverse(all(need));
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int l = 0; l < (1<<k); ++l) {
                dp[i][j][l] = 0;
            }
        }
    }
    for (int i = 0; i < need.size(); ++i) {
        take += (need[i]=='1' ? 1<<i : 0);
    }
    for (int i = 0; i < (1<<k); ++i) {
        if (take == i) {
            dp[1][k - 1][i]++;
        }
        else {
            dp[0][k - 1][i]++;
        }
    }
    for (int i = k; i < n; ++i) {
        for (int b : can) {
            int c = b&((1<<k)-1);
            if (c == take) {
                dp[1][i][c] = add(dp[1][i][c], add(dp[0][i - 1][b/2], dp[1][i - 1][b/2]));
            }
            else {
                dp[0][i][c] = add(dp[0][i][c], dp[0][i - 1][b/2]);
                dp[1][i][c] = add(dp[1][i][c], dp[1][i - 1][b/2]);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < (1<<k); ++i)
        ans = add(ans, dp[1][n - 1][i]);
    return ans;
}

int pd[2][1<<(1<<4)];

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> n >> m >> k >> w;
    int can = (1<<(k+1));
    for (int mask = 0; mask < (1<<can); ++mask) {
        vector<int> A;
        for (int i = 0; i < can; ++i) {
            if ((mask >> i)&1) {
                A.push_back(i);
            }
        }
        pd[0][mask] = count(n, A, w);
        pd[1][mask] = count(m, A, w);
    }
    for (int mask = 0; mask < (1<<can); ++mask) {
        for (int smask = (mask-1)&mask; ; smask = (smask - 1) & mask) {
            pd[0][mask] = sub(pd[0][mask], pd[0][smask]);
            pd[1][mask] = sub(pd[1][mask], pd[1][smask]);
            if (smask == 0) break;
        }
    }
    for (int mask = 1; mask < (1<<can); ++mask) {
        if (n == k) pd[0][mask] = 0;
        if (m == k) pd[1][mask] = 0;
    }
    if (n == k) pd[0][0] = 1;
    if (m == k) pd[1][0] = 1;

    int ans = 0;
    for (int mask = 0; mask < (1<<can); ++mask) {
        for (int smask = mask; ; smask = (smask - 1) & mask) {
            ans = add(ans, mul(pd[0][mask^smask], pd[1][smask]));
            if (smask == 0) break;
        }
    }
    cout << ans << '\n';
    
}
