#include <bits/stdc++.h>
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define f first
#define s second

using namespace std;
using ll = long long;
using pii = pair <int, int>;
const int N = 2e5 + 5;

int t;
int n;
vector < pii > r, g, rr, gg;


void solve() {
	cin >> n;
	r.clear(), g.clear();
	
	ll sr = 0, sg = 0;
	for (int i = 1; i <= n; ++i) {
		int x, m;
		char c;
		cin >> x >> m >> c;
		if (c == 'R') {
			r.pb({x, m});
			sr += m;
		} else {
			g.pb({x, m});
			sg += m;
		}
	}
	
	sort(all(r));
	reverse(all(r));
	
	sort(all(g));
	reverse(all(g));
	
	rr = r, gg = g;
	
	
	if (sr == sg) {
		cout << "DRAW 0 0\n";
		return;
	}
	
	
	if (sr > sg) {
		int j = 0;
		bool win = 1;
		
		ll s = 0;
		for (int i = 0; i < sz(g); ++i) {
			while (j < sz(r) && g[i].s > 0) {
				int cur = min(g[i].s, r[j].s);
				s += cur * 1ll * (g[i].f - r[j].f);				
				g[i].s -= cur;
				r[j].s -= cur;
				if (s > 1) {
					win = 0;
					break;
				}
				if (!j)
					j++;
				else
					break;
			}
		}
		
		if (!win)
			cout << "DRAW ";
		else
			cout << "FIRST ";
		
		cout << r[0].f << " +";
		cout << "\n";
		return;
	}
	
	//sr < sg
	g = rr, r = gg;
	int j = 0;
	bool win = 1;
	
	ll s = 0;
	for (int i = 0; i < sz(g); ++i) {
		while (j < sz(r) && g[i].s > 0) {
			int cur = min(g[i].s, r[j].s);
			s += cur * 1ll * (g[i].f - r[j].f);
			g[i].s -= cur;
			r[j].s -= cur;
			if (s > 0) {
				win = 0;
				break;
			}
			if (!j)
				j++;
			else
				break;
		}
	}
	
	if (!win) {		
		cout << "DRAW ";
		cout << g[0].f << " +";
	} else
		cout << "SECOND ";
		
	cout << "\n";	
}

int main() {
	ios :: sync_with_stdio(0);
	cin.tie(0);
	cin >> t;
	while (t--)
		solve();
	return 0;
}
