#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 1e5 + 10;
int h[N], p[N];
int ord[N];

int solve(int n) {
    for (int i = 1; i <= n; i++) {
        if (p[i] < h[i]) {
            return -1;
        }
    }
    iota(ord + 1, ord + n + 1, 1);
    sort(ord + 1, ord + n + 1, [&](int i, int j) {
        return p[i] < p[j];
    });
    for (int i = 1; i <= n - 1; i++) {
        if (h[ord[i]] > h[ord[i + 1]]) {
            return -1;
        }
        if (p[ord[i]] - h[ord[i]] > p[ord[i + 1]] - h[ord[i + 1]]) {
            return -1;
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        ans = max(ans, p[i] - h[i]);
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        for (int i = 1; i <= n; i++) {
            cin >> h[i];
        }
        for (int i = 1; i <= n; i++) {
            cin >> p[i];
        }
        cout << solve(n) << "\n";
    }

#ifdef LOCAL
    cout << "\nTime elapsed: " << double(clock()) / CLOCKS_PER_SEC << " s.\n";
#endif
}