//#pragma comment(linker, "/stack:20000000")
//#pragma GCC optimize("Ofast,O3,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx2,bmi,bmi2,popcnt,lzcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

#define ll long long
#define int ll
#define f first
#define s second
#define fi first
#define se second
#define ss size()
#define pii pair < int, int >
#define si set < int >
#define vi vector < int >
#define spii set < pii >
#define mii map < int, int >
#define umii unordered_map < int, int >
#define FOR(i, l, r) for (int i = l; i <= r; i++)
#define ROF(i, r, l) for (int i = r; i >= l; i--)
#define FOR1(i, l, r, x) for (int i = l; i <= r; i += x)
#define all(v) v.begin(), v.end()
#define srt(a, n) sort(a + 1, a + n + 1)
#define rvs(a, n) reverse(a + 1, a + n + 1)
//#define fi(n) for(ll i = 0; i < n; i++)
#define fj(n) for(ll j = 0; j < n; j++)
#define fk(n) for(ll k = 0; k < n; k++)
#define fio(n) for(ll i = 1; i < n; i++)
#define fjo(n) for(ll j = 1; j < n; j++)
#define fko(n) for(ll k = 1; k < n; k++)
#define move kdfkjb

template<class T, class comp=less<T> > using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, comp, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
inline int rng(int l, int r) {return (rnd()%(r-l+1) + l);}
template <class T, class U> bool emin(T& a, const U& b) {return b < a ? a = b, 1 : 0;}
template <class T, class U> bool emax(T& a, const U& b) {return b > a ? a = b, 1 : 0;}
template <class T, class U> bool erase(T& t, const U& u){
    auto it = t.find(u);
    if (it != t.end()) {t.erase(it); return 1;}
    return 0;
}

#define dbg(...) do { cout << "DBG: " << (#__VA_ARGS__) << ": "; dbg_vals(__VA_ARGS__); cout << "\n";} while (0);
template<typename iter, typename=decltype(declval<iter>().begin()), typename=enable_if<!is_convertible<iter, string>::value>> ostream& operator<<(ostream& out, const iter& x) { for(const auto& i : x) out << i << ' '; return out; }
template<typename T>void dbg_vals(T x){ cout << x; }
template<typename T, typename... Args> void dbg_vals(T x, Args... args){ dbg_vals(x); cout << " | "; dbg_vals(args...); }

const ll INF = 1e15 + 9;
const int N = 2e5 + 40, inf = 1e9 + 7, T = 4 * N, mod = 998244353;
int n, m, e, f, w, l, r, id, timer;

int a[N], b[N], us[N], d[N][4];

int move(int i, int st, int fn)
{
    if (i <= 0) return 0;
    //cout << "move " << i << " " << st << " " << fn << endl;
    //if (us[i]) return d[i][abs(st-fn)];
    us[i] = 1;
    int cnt = 0;
    if (st == fn){
        return move(i - 1, a[i - 1], fn);
    }
    if (abs(st - fn) == 2)
    {
        cnt += move(i - 1, a[i - 1], fn);
        a[i] = 2;
        cnt++;
        //cout << "moved " << i << " " << st << " " << 2 << endl;
        //cnt += move(i - 1, fn, st);
        cnt += d[i - 1][abs(fn - st)];
        a[i] = fn;
        cnt++;
        //cout << "moved " << i << " " << 2 << " " << fn << endl;
        //cnt += move(i - 1, st, fn);
        cnt += d[i - 1][abs(fn - st)];
    }
    else
    {
        cnt += move(i - 1, a[i - 1], 6 - st - fn);
        cnt++;
        //cout << "moved " << i << " " << st << " " << fn << endl;
        //cnt += move(i - 1, 6 - st - fn, fn);
        cnt += d[i - 1][abs(6 - st - fn - fn)];
    }
    a[i] = fn;
    return cnt % mod;
}

void solve()
{
    cin >> n;
    FOR (i, 1, n)
    {
        cin >> a[i];
    }
    FOR (i, 1, n) cin >> b[i];

    FOR (i, 1, n) us[i] = 0;
    f = move(n, a[n], b[n]);
    FOR (i, 1, n)
    {
        a[i] = b[i];
        us[i] = 0;
    }
    e = move(n - 1, a[n - 1], b[n]);
    cout << (f - e + mod) % mod;
    //cout << endl << f << " " << e;
}

signed main(){
    #ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
    #else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #endif // LOCAL

    n = 1e5;
    FOR (i, 1, n)
    {
        d[i][2] = (d[i - 1][2] * 3 + 2) % mod;
        d[i][1] = (d[i - 1][1] * 3 + 1) % mod;
    }

    int _ = 1;
    cin >> _;
    while (_--)
    {
        solve();
        cout << endl;
    }
}
