//#pragma comment(linker, "/stack:20000000")
//#pragma GCC optimize("Ofast,O3,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx2,bmi,bmi2,popcnt,lzcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

#define ll long long
#define int ll
#define f first
#define s second
#define fi first
#define se second
#define ss size()
#define pii pair < int, int >
#define si set < int >
#define vi vector < int >
#define spii set < pii >
#define mii map < int, int >
#define umii unordered_map < int, int >
#define FOR(i, l, r) for (int i = l; i <= r; i++)
#define ROF(i, r, l) for (int i = r; i >= l; i--)
#define FOR1(i, l, r, x) for (int i = l; i <= r; i += x)
#define all(v) v.begin(), v.end()
#define srt(a, n) sort(a + 1, a + n + 1)
#define rvs(a, n) reverse(a + 1, a + n + 1)
#define fi(n) for(ll i = 0; i < n; i++)
#define fj(n) for(ll j = 0; j < n; j++)
#define fk(n) for(ll k = 0; k < n; k++)
#define fio(n) for(ll i = 1; i < n; i++)
#define fjo(n) for(ll j = 1; j < n; j++)
#define fko(n) for(ll k = 1; k < n; k++)

template<class T, class comp=less<T> > using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, comp, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
inline int rng(int l, int r) {return (rnd()%(r-l+1) + l);}
template <class T, class U> bool emin(T& a, const U& b) {return b < a ? a = b, 1 : 0;}
template <class T, class U> bool emax(T& a, const U& b) {return b > a ? a = b, 1 : 0;}
template <class T, class U> bool erase(T& t, const U& u){
    auto it = t.find(u);
    if (it != t.end()) {t.erase(it); return 1;}
    return 0;
}

#define dbg(...) do { cout << "DBG: " << (#__VA_ARGS__) << ": "; dbg_vals(__VA_ARGS__); cout << "\n";} while (0);
template<typename iter, typename=decltype(declval<iter>().begin()), typename=enable_if<!is_convertible<iter, string>::value>> ostream& operator<<(ostream& out, const iter& x) { for(const auto& i : x) out << i << ' '; return out; }
template<typename T>void dbg_vals(T x){ cout << x; }
template<typename T, typename... Args> void dbg_vals(T x, Args... args){ dbg_vals(x); cout << " | "; dbg_vals(args...); }

const ll INF = 1e15 + 9;
const int N = 2e5 + 40, inf = 1e9 + 7, T = 4 * N, MOD = 998244353;
int n, m, e, f, w, l, r, id, timer;

ll k;

ll get_lastk(ll x){
    return x&((1<<k)-1);
}

int dp[103][16][1<<16][2];
ll smm[1<<16];
ll asda[1<<16];

void solve()
{
    //dbg(sizeof(dp))
    string s;
    cin >> n >> m >> k >> s;
    ll need = 0;
    for(char i : s) need = need*2 + (i - '0');
    const ll LAST_K = (1<<k)-1;
    const ll BIT = ((1<<(k+1))-1);
    const ll MXMASK = (1<<(1<<(k+1)));
    //dbg(BIT, MXMASK)
    dp[0][0][0][0] = 1;
    if (m > n) swap(n, m);
    fi(n+1) for(ll mask = 0; mask <= BIT; mask++) fj(MXMASK) for(ll was = 0; was < 2; was++) {
        if (!dp[i][mask][j][was]) continue;
        //dbg(i, mask, bitset<8>(j), was, dp[i][mask][j][was])
        for(ll st = 0; st < 2; st++){
            ll nj = j;
            ll nmask = (mask*2+st)&BIT;
            if (i >= k) nj |= 1<<nmask;
            ll nwas = was;
            if(i+1 >= k && (nmask&LAST_K) == need) nwas = true;
            (dp[i+1][nmask][nj][nwas] += dp[i][mask][j][was]) %= MOD;
        }
    }
    for(ll mask = 0; mask <= BIT; mask++) fj(MXMASK) (smm[j] += dp[n][mask][j][1]) %= MOD;
    //fj(MXMASK) if (smm[j]) dbg(bitset<8>(j), smm[j])
    //cout << '\n';
    fj(MXMASK){
        for(ll mask = j; ; mask = (mask-1)&j){
            if ((j&mask) == mask) (asda[j] += smm[mask]) %= MOD;
            if (!mask) break;
        }
    }
    //fj(MXMASK) if(asda[j]) dbg(bitset<8>(j), asda[j])
    //cout << '\n';
    fj(MXMASK) smm[j] = 0;
    for(ll mask = 0; mask <= BIT; mask++) fj(MXMASK) (smm[j] += dp[m][mask][j][1]) %= MOD;
    //fj(MXMASK) if (smm[j]) dbg(bitset<8>(j), smm[j])
    //cout << '\n';
    ll ans = 0;
    //dbg(need)
    const ll NEED = (1<<need) | (1<<((1<<(k+1)) + need)) | (1<<(2*need)) | (1<<(2*need+1));
    //dbg(bitset<16>(NEED))
    fi(MXMASK){
        ll inv = (~i)&(MXMASK-1);
            //dbg(bitset<8>(i), bitset<8>(inv), smm[i], asda[inv])
            (ans += smm[i] * asda[inv]) %= MOD;
    }
    cout << ans << '\n';

}

signed main(){
    #ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
    #else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #endif // LOCAL

    int _ = 1;
    //cin >> _;
    while (_--)
    {
        solve();
        cout << endl;
    }
}
