#include <bits/stdc++.h>
using namespace std;
 
#define all(x) (x).begin(), (x).end()
#define ll long long
#define vi vector<int>
#define pii pair<int, int>
#define vii vector<pii>
#define forn(i, n) for(int i = 0; i < (n); i++)
#define vll vector<ll>
 
const char nl = '\n';
const int inf = 1e9+123;
const int mod = 1e9+7;
const int N = 1e5 + 12;
 
int n, m, a, b, in[N], out[N];
pii t[4 * N], r[4 * N];
vector<int> g[N], q[N];
bool was[N];
 
void bld(int v = 1, int tl = 0, int tr = n - 1) {
    if(tl == tr) {
        t[v].first = in[tl];
        t[v].second = tl;
    } else {
        int mid = (tl + tr) >> 1;
        bld(v << 1, tl, mid);
        bld(v << 1 | 1, mid + 1, tr);
        t[v].first = min(t[v << 1].first, t[v << 1 | 1].first);
        if(t[v << 1].first < t[v << 1 | 1].first) {
            t[v].second = t[v << 1].second;
        }else {
            t[v].second = t[v << 1 | 1].second;
        }
    }
}
 
void upd(int pos, int x, int v = 1, int tl = 0, int tr = n - 1) {
    if(tl == tr) {
        t[v].first += x;
    } else {
        int mid = (tl + tr) >> 1;
        if(pos <= mid) {
            upd(pos, x, v << 1, tl, mid);
        } else {
            upd(pos, x, v << 1 | 1, mid + 1, tr);
        }
         
        t[v].first = min(t[v << 1].first, t[v << 1 | 1].first);
        if(t[v << 1].first < t[v << 1 | 1].first) {
            t[v].second = t[v << 1].second;
        }else {
            t[v].second = t[v << 1 | 1].second;
        }
    }
}
 
void bld2(int v = 1, int tl = 0, int tr = n - 1) {
    if(tl == tr) {
        r[v].first = in[tl];
        r[v].second = tl;
    } else {
        int mid = (tl + tr) >> 1;
        bld2(v << 1, tl, mid);
        bld2(v << 1 | 1, mid + 1, tr);
        r[v].first = max(r[v << 1].first, r[v << 1 | 1].first);
        if(r[v << 1].first > r[v << 1 | 1].first) {
            r[v].second = r[v << 1].second;
        }else {
            r[v].second = r[v << 1 | 1].second;
        }
    }
}
 
void upd2(int pos, int x, int v = 1, int tl = 0, int tr = n - 1) {
    if(tl == tr) {
        r[v].first += x;
    } else {
        int mid = (tl + tr) >> 1;
        if(pos <= mid) {
            upd2(pos, x, v << 1, tl, mid);
        } else {
            upd2(pos, x, v << 1 | 1, mid + 1, tr);
        }
         
        r[v].first = max(r[v << 1].first, r[v << 1 | 1].first);
        if(r[v << 1].first > r[v << 1 | 1].first) {
            r[v].second = r[v << 1].second;
        }else {
            r[v].second = r[v << 1 | 1].second;
        }
    }
}
 
void trash(int v = 1, int tl = 0, int tr = n - 1) {
    if(tl == tr) {
        t[v].first = t[v].second = 0;
        r[v].first = r[v].second = 0;
    } else {
        int mid = (tl + tr) >> 1;
        trash(v << 1, tl, mid);
        trash(v << 1 | 1, mid + 1, tr);
        t[v].first = t[v].second = 0;
        r[v].first = r[v].second = 0;
    }
}
 
void solve() {
    cin >> n >> m;
    for(int i = 0; i < m; ++i) {
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        q[b].push_back(a);
        out[a]++;
        in[b]++;
    }
    bld();
    bld2();
     
    vector<int> ans;
    int cnt = 0, tnc = 0;
    while(tnc < n) {
        // t for min
        // r for max
        if(t[1].first == 0) {
            int v = t[1].second;
            ++cnt;
            ans.push_back(v);
             
            for(int &to : g[v]) {
                if(!was[to]) {
                    upd(to, -1);
                }
            }
            upd(v, inf);
            upd2(v, -inf);
            was[v] = 1;
        } else {
            int v = r[1].second;
            ans.push_back(v);
             
            for(int &to : g[v]) {
                if(!was[to]) {
                    upd(to, -1);
                }
            }

            upd(v, inf);
            upd2(v, -inf);
            was[v] = 1;
        }
        ++tnc;
    }
//  cout << cnt << nl;
    if(cnt >= (m + 1) / 2) {
        for(int &x : ans) {
            cout << x + 1 << ' ';
        }
    } else {
        cout << -1;
    }
     
    for(int i = 0; i < n; ++i) {
        g[i].clear();
        q[i].clear();
        was[i] = 0;
        in[i] = out[i] = 0;
    }
    trash();
}
  
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
     
    int T = 1;
    cin >> T;
    while(T--) {
        solve();
        cout << nl;
    }
}
