#include <bits/stdc++.h>
#define pb push_back
#define ff first
#define ss second
#define goodluck ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define int long long
#define ENDL "\n"
using namespace std;

#define L 2 * x + 1
#define R 2 * x + 2
#define M (xl + xr) / 2
#define LL xl, M
#define RR M, xr

vector<int> t, d;


void build(int x, int xl, int xr, vector<int>& a){
	if(xr - xl == 1){
		t[x] = a[xl];
		return;
	}
	build(L, LL, a);
	build(R, RR, a);
	t[x] = t[R] + t[L];
}

void push(int x, int xl, int xr){
	if(d[x]){
		t[L] += d[x] * (M - xl);
		t[R] += d[x] * (xr - M);
		d[L] += d[x];
		d[R] += d[x];
		d[x] = 0;
	}
}
int get(int l, int r, int x, int xl, int xr){
	if(xl >= r or xr <= l) return 0;
	
	if(xl >= l and xr <= r){
		return t[x];
	}
	push(x, xl, xr);
	
	return get(l, r, L, LL) + get(l, r, R, RR);
	
}

void add(int l, int r, int x, int v, int xl, int xr){
	if(xl >= r or xr <= l) return;
	
	if(xl >= l and xr <= r){
		t[x] += v * (xr - xl);
		d[x] = v;
		return;
	}
	push(x, xl, xr);
	
	add(l, r, L, v, LL);
	add(l, r, R, v, RR);
}

void print_TREE(int x, int tab, int mx){
	if(mx <= x) return;
	print_TREE(R, tab + 4, mx);
	for(int i = 0; i < tab; i++){
		cout << "|";
	}
	cout << "( " << t[x] << ", " << " )" << ENDL;
	print_TREE(L, tab + 4, mx);
}

vector<int> p, r;

int get(int a){
	if(a != p[a]){
		p[a] = get(p[a]);
	}
	return p[a];
}

void join(int a, int b){
	a = get(a);
	b = get(b);
	if(a == b){
		return;
	}
	if(r[a] > r[b]) swap(a, b);
	
	p[a] = p[b];
	
	if(r[a] == r[b]){
		r[b]++;
	}
	
}

bool cmp(pair<int, int> a, pair<int, int> b) {
//	if(a.ff == b.ff)
//		return a.ss < b.ss;
//	else	return a.ff < b.ff;
	return a <= b;
}


void solve(){
	int n, e; cin>>n>>e; string s;
	map<char, int> ban; vector<string> b;
	map<char, int> c;
	for(int i = 0; i < n; i++) {
		cin>>s; map<char, int> mp;
		for(int i = 0; i < s.length(); i++) {
			mp[s[i]]++;
		}
		if(mp.size() == 1) {
			ban[s[0]] = 1;
		} else {
			b.pb(s);
			int k = 0;
			for(int i = 0; i < s.length(); i++) {
				if(s[i] == s[0]) {
					k++;
				} else {
					break;
				}
			}
			c[s[0]] = c[s[0]] + k;
		}
	}
	/*for(auto i : ban)
		cout<<i.ff<<""<<i.ss<<endl;
	cout<<endl;*/
	int ans = 1e18; char cans;
	if(ban.size() == e) {
		cout<<"NO"<<endl;
		return;
	}
	for(int i = 0; i < e; i++) {
		if(ban[i + 'a'] == 0) {
			if(c[i + 'a'] == 0) {
				cout<<char(i + 'a')<<endl;
				return;
			}
			if(c[i + 'a'] + 1 < ans && c[i + 'a'] != 0) {
				ans = c[i + 'a'] + 1;
				cans = i + 'a';
			}
		}
	}
	string res = "";
	for(int i = 0; i < ans; i++)
		res += cans;
	cout<<res<<endl;
}


signed main()
{
	
	goodluck
	
	int T;
	T = 1;
	while(T--) {
		solve();
	}
	
	return 0;
}
