#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define f first
#define s second
#define ndl '\n'
#define pb push_back
typedef long long ll;

using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
long long rand(long long l, long long r) {
	return uniform_int_distribution<long long> (l,r)(rng);
}

const int MOD = 998244353;

ll h(ll n) {
	if (n == 1) return 2;
	return (3*h(n-1)%MOD + 2) % MOD;
}

ll mf(const vector<int>& x, int n) {
	if (n == 1) return 3 - x[n];
	if (x[n] == 1) return (mf(x, n -1) + 2 + 2*h(n-1)) % MOD;
	if (x[n] == 2) return (mf(x, n -1) + 1 + 2*h(n-1)) % MOD;
	if (x[n] == 3) return mf(x, n -1);
}

ll ms(const vector<int>& x, int n) {
	if (n == 1) return x[n] - 1;
	if (x[n] == 1) return ms(x, n -1) ;
	if (x[n] == 2) return (ms(x, n -1) + 1 + 2*h(n-1)) % MOD;
	if (x[n] == 3) return (ms(x, n -1) + 2 + 2*h(n-1)) % MOD;
}

ll f(const vector<int>& x, const vector<int>& y, int n) {
	if (n == 1) return abs(x[1] - y[1]);
	if (abs(x[n] - y[n]) == 1) return (mf(x, n-1) + mf(y, n-1) + 1) % MOD;
	if (abs(x[n]- y[n]) == 2) {
		if (x[n] < y[n]) {
			return (mf(x, n-1) + (2 + h(n-1) + ms(y, n-1) % MOD)) % MOD;
		}
		if (x[n] > y[n]) {
			return (ms(x, n-1) + (2 + h(n-1) + mf(y, n-1)) % MOD) % MOD;
		}
	} else {
		return f(x, y, n-1);
	}
	
}

void solve() {
	int n;
	cin >> n;
	vector<int> x(n+1), y(n+1);
	for (int i = 1; i <= n; ++i) cin >> x[i];
	for (int i = 1; i <= n; ++i) cin >> y[i];
	cout << f(x, y, n) << ndl;
	
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	cin >> tt;
	while(tt--) {
		solve();
	}
}
