#include <bits/stdc++.h>
 
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define f first
#define s second
#define ndl '\n'
#define pb push_back
typedef long long ll;
 
using namespace std;
 
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
long long rand(long long l, long long r) {
    return uniform_int_distribution<long long> (l,r)(rng);
}
 
void solve() {
    int n, m;
    cin >> n >> m;
     
    vector<vector<int>> g(n+1);
    vector<pair<int, int>> e;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].pb(v);
        e.pb(make_pair(u, v));
    }
     
    vector<int> used(n+1);
    vector<int> ts;
    function<void(int)> dfs = [&](int v) {
        used[v] = 1;
        for (auto to : g[v]) {
            if (used[to]) continue;
            dfs(to);
        }
        ts.pb(v);
    };
     
     for (int v = 1; v <= n; ++v) {
     	if (!used[v])
     	  dfs(v);
	 }
  
    reverse(all(ts));
    vector<int> ord(n+1);
    for (int i = 0; i < (int)ts.size(); ++i) {
        ord[ts[i]] = i;
    }
     
    int k = m;
    for (auto [u, v] : e) {
        if (ord[u] > ord[v]) {
            k--;
        }
    }
     
    if (k < (m+1)/2) {
        cout << -1;
    } else {
        for (auto x : ts) cout << x << ' ';
    }
    cout << ndl;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
    cin >> tt;
    while(tt--) {
        solve();
    }
}
