#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define f first
#define s second
#define ndl '\n'
#define pb push_back
typedef long long ll;

using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
long long rand(long long l, long long r) {
	return uniform_int_distribution<long long> (l,r)(rng);
}

void solve() {
	int n, m;
	cin >> n >> m;
	
	vector<vector<int>> g(n+1), gg(n+1);
	vector<int> out(n + 1), in(n+1);
	set<pair<int, int>> s;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		g[v].pb(u);
		gg[u].pb(v);
		in[v]++;
		out[u]++;
	}
	
	for (int i = 1; i <= n; ++i) {
		s.insert({in[i] - out[i], i});
	}
	
	set<pair<int, int>> bad;
	vector<int> used(n + 1);
	while (s.size()) {
		auto [x, v] = *s.begin();
//		cout << v << ' ' << out[v] << ' ' << in[v] << '\n';
		s.erase(s.begin());
		used[v] = 1;
		for (auto to : g[v]) {
			if (used[to]) continue;
			s.erase({in[to] - out[to], to});
			out[to]--;
			s.insert({in[to] - out[to], to});
			bad.insert({to, v});
		}
	}
	
//	for (auto [u, v] : bad) {
//		cout << u << ' ' << v << ndl;
//	}
	
	vector<int> us(n+1);
	vector<int> ts;
	function<void(int)> dfs = [&](int v) {
		us[v] = 1;
		for (auto to : gg[v]) {
			if (us[to]) continue;
			if (bad.count({v, to})) continue;
			dfs(to);
		}
		ts.pb(v);
	};
	
	for (int v = 1; v <= n; ++v) {
		if (!us[v])
		  dfs(v);
	}

	reverse(all(ts));
	
	int k = m - bad.size();
	if (k < (m+1)/2) {
		cout << -1;
	} else {
		for (auto x : ts) cout << x << ' ';
	}
	cout << ndl;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	cin >> tt;
	while(tt--) {
		solve();
	}
}
