#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define mk make_pair
#define f first
#define s second
#define vt vector 
#define dbg(x) cout << (#x) << ": " << (x) << '\n';
#define en '\n'

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define rev(x) reverse(x.begin(), x.end())
#define sz(x) (int)x.size()

template <class T, class TT> void mineq(T& a, const TT& b){ if(b < a) a = b; }
template <class T, class TT> void maxeq(T& a, const TT& b){ if(b > a) a = b; } 

#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef double ld;
typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<pair<int, int>> vii;
typedef vector<pair<ll, ll>> vll;

const int N = 1e5 + 100;
int n, m;
vector<int> g[N];
bool used[N];
vector<int> ans;

void dfs(int v) {
	used[v] = 1;
	for (int to: g[v]) {
		if (!used[to]) {
			dfs(to);
		}
	}
	ans.pb(v);
}

void top_sort() {
	for (int i = 1; i <= n; i++) {
		used[i] = 0;
	}
	ans.clear();
	for (int i = 1; i <= n; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	reverse(all(ans));
}

void solve(){
	cin >> n >> m;
	for (int i = 1; i <= n; i++) {
		g[i].clear();
		used[i] = 0;
	}
	for (int i = 1; i <= m; i++) {
		int f, t;
		cin >> f >> t;
		g[f].pb(t);
	}
	top_sort();
	vector<int> mp(n + 1);
	for (int i = 0; i < ans.size(); i++) {
		mp[ans[i]] = i;
	}
	int bad = 0;
	for (int i = 1; i <= n; i++) {
		for (int to: g[i]) {
			if (mp[i] > mp[to]) {
				bad++;
			}
		}
	}
	if (bad > m / 2) {
		reverse(all(ans));
	}
	for (int x: ans) cout << x << ' ';
	cout << en;
}

int main(){
	fast_io;

	int test_cases = 1;
	cin >> test_cases;
	for(int test_case = 1;test_case <= test_cases;++test_case){
		// cout << "Case #" << test_case << en;
		solve();
	}
}