#include <bits/stdc++.h>

using namespace std;


#define ll long long
#define pii pair<long long, long long>
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

#define minHeap priority_queue<pii, vector<pii>, greater<pii>> 


#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)



int n, m;
int cnt;

void dfs(int v, vector<minHeap>& g, vector<int>& c, vector<int>& od) {
	c[v] = 1;
	while (g[v].size()) {
		int to = g[v].top().second;
		g[v].pop();

		if (c[to] == 0) {
			dfs(to, g, c, od);
		}
		else if (c[to] == 1) {
			cnt++;
		}
	}
	c[v] = 2;
	od.push_back(v);
}

void solve() {
	cin >> n >> m;
	cnt = 0;

	vector<vector<int>> a(n + 1);
	vector<int> inDeg(n + 1, 0);

	for (int j = 0; j < m; j++) {
		int x, y;
		cin >> x >> y;
		if (x == y)
			continue;
		a[x].pb(y);
		inDeg[y]++;
	}

	vector<minHeap> g(n + 1);
	vector<pii> temp;

	for (int i = 1; i <= n; i++) {
		for (int to : a[i]) {
			g[i].push({inDeg[to], to});
		}
		temp.pb({inDeg[i], i});
	}

	sort(all(temp));


	vector<int> c(n + 1, 0);
	vector<int> od;

	for (pii& p : temp) {
		int j = p.second;
		// cout << "dbg j : " << j << "\n";
		if (c[j] == 0) {
			dfs(j, g, c, od);
		}
	}

	cnt = m - cnt;

	if (cnt < ((m+1) / 2)) {
		cout << -1  << "\n";
		return;
	}

	// cout << cnt << "\n";

	reverse(all(od));

	// cout << "cnt: " << cnt << ", ";
	// cout << "order: ";
	for (int  x : od) {
		cout << x << " ";
	}
	cout << "\n";
}


int main() {
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
	
	boost;

	int t = 1;
	cin >> t;
	for (int i = 1; i <= t; i++)
		solve();

	return 0;
}