#include <bits/stdc++.h>
#define ll long long
#define pb push_back
#define all(v) v.begin(), v.end();

using namespace std;

const int N = 1e5 + 5;
const ll mod = 998244353;

ll n;
ll start[N], finish[N];
ll dp[N];

void solve()
{
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> start[i];
    for (int i = 1; i <= n; ++i)
        cin >> finish[i];

    int largest = -1;
    for (int i = n; i >= 1; --i)
    {
        if (start[i] != finish[i])
        {
            largest = i;
            break;
        }
    }

    if (largest == -1)
    {
        cout << "0\n";
        return;
    }

    ll cnt[4] = {0, 0, 0, 0};
    ll second = 0;

    ll next = -1;
    if (start[largest] == 1)
        next = 3;
    else if (start[largest] == 3)
        next = 1;
    else if (finish[largest] == 3)
        next = 1;
    else
        next = 3;

    ll ans = 0;
    for (int i = largest - 1; i >= 1; --i)
    {
        ll col = 0;
        for (int j = 1; j <= 3; ++j)
            col += cnt[j];

        col *= 2;
        if (start[i] != next)
            ++col;

        if (start[i] == 2)
            col -= second;

        col %= mod;

        // cout << col << " ";

        if (i < largest)
            (ans += (col * 2 - (start[i] == 2))) %= mod;

        if (start[i] == 2)
        {
            ++second;
        }
        (cnt[start[i]] += col) %= mod;
    }

    dp[1] = 1;
    for (int i = 2; i <= n; ++i)
    {
        (dp[i] = dp[i - 1] * 3ll + 1) %= mod;
    }

    if (start[largest] == 2 || finish[largest] == 2)
    {
        (++ans) %= mod;
    }
    else
    {
        (++ans) %= mod;
        (ans += 2ll * dp[largest - 1]) %= mod;
        (++ans) %= mod;
        if (next == 1)
            next = 3;
        else
            next = 1;
    }

    for (int i = largest - 1; i >= 1; --i)
    {
        if (next == finish[i])
            continue;

        if (finish[i] == 2)
        {
            (ans += 2ll * dp[i - 1]) %= mod;
            (++ans) %= mod;
            if (next == 1)
                next = 3;
            else
                next = 1;
        }
        else
        {
            (ans += 4ll * dp[i - 1]) %= mod;
            (ans += 2) %= mod;
        }
    }

    cout << ans << "\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tt;
    cin >> tt;
    while (tt--)
    {
        solve();
    }

    return 0;
}

/*
1
6
1 3 3 2 1 3
3 3 3 1 2 1
*/