#include<bits/stdc++.h>

#define ll long long
#define pb push_back
#define sz(x) (int)((x).size())
#define vi vector<int>
#define pii pair<int,int>
#define all(x) x.begin(), x.end()

using namespace std;

const ll mod = (ll)1e9+7;
const ll inf = (ll)1e18+7;
const int N = (int)2e5 + 100;
const int M = (int)1e7 + 100;
const double eps = 1e-9;
const char nl = '\n';

int n, m;
vi g[N];
int u[N];
vi top;

void dfs(int v) {
    u[v] = 1;
    for(auto to : g[v]) {
        if(!u[to]) {
            dfs(to);
        }
    }
    top.pb(v);
}

void solve() {
    cin >> n >> m;
    for(int i = 1; i <= m; i++) {
        int fr, to;
        cin >> fr >> to;
        g[fr].pb(to);
    }
    for(int i = 1; i <= n; i++) {
        if(!u[i])
            dfs(i);
    }
    reverse(all(top));
    for(auto i : top)   cout << i << " ";
    top.clear();
    for(int i = 1; i <=n ; i++)u[i] = 0;
    for(int i = 1; i <= n; i++)g[i].clear();
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int times = 1;
    cin >> times;
    for(int i = 1; i <= times; i++) {
        //cout << "Case " << i << ": ";
        solve();
        cout << nl;
    }
}
