#include<bits/stdc++.h>

using namespace std;

#define ll long long
#define sz(x) (int)size(x)
#define all(x) x.begin(),x.end()
#define fi first
#define se second

const int N = 2e5+7;
const int E9 = 1e9;

vector<int> g[N], gr[N], ts;
int ans[N], num, cl[N];
bool us[N];

int dfs(int v)
{
    us[v] = true;
    int sum = 0;
    for (auto to: g[v])
    {
        sum += (ans[v] < ans[to] ? 1 : 0);
        if (!us[to]) sum += dfs(to);
    }
    return sum;
}

void dfs1(int v)
{
    us[v] = true;
    for (auto to: g[v])
    {
        if (!us[to]) dfs1(to);
    }
    ts.push_back(v);
}

void dfs2(int v, int color)
{
    us[v] = true;
    cl[v] = color;
    for (auto to: gr[v])
    {
        if (!us[to]) dfs2(to, color);
    }
}

void dfs3(int v)
{
    us[v] = true;
    num++;
    ans[v] = num;
    for (auto to: g[v])
    {
        if (!us[v] && cl[v] == cl[to]) dfs3(to);
    }
}

void solve()
{
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= m; ++i)
    {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        gr[v].push_back(u);
    }
    for (int i = 1; i <= n; ++i)
    {
        if (!us[i]) dfs1(i);
    }
    fill(us + 1, us + 1 + n, false);
    num = 0;
    int color = 0;
    for (int i = 1; i <= n; ++i)
    {
        int v = ts[n - i];
        if (!us[v])
        {
            color++;
            dfs2(v, color);
        }
    }
    fill(us + 1, us + 1 + n, false);
    for (int i = 1; i <= n; ++i)
    {
        int v = ts[n - i];
        if (!us[v]) dfs3(v);
    }
    fill(us + 1, us + 1 + n, false);
    int cnt = 0;
    for (int i = 1; i <= n; ++i)
    {
        if (!us[i]) cnt += dfs(i);
    }
    ts.clear();
    for (int i = 1; i <= n; ++i)
    {
        cl[i] = 0;
        g[i].clear();
        gr[i].clear();
        us[i] = false;
    }
    if (cnt < (m + 1) / 2)
    {
        cout << -1;
        return;
        cout << '\n';
    }
    for (int i = 1; i <= n; ++i)
    {
        cout << ans[i] << ' ';
        ans[i] = 0;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int q;
    cin >> q;
    while(q--)
    {
        solve();
        cout << '\n';
    }
}
