#include "bits/stdc++.h"
using namespace std;

void printer(){
    cout << '\n';
}
template<typename T, typename... V>
void printer(T t, V... v){
    cout << t << ' ';
    printer(v...);
}

#ifndef ONLINE_JUDGE
#define deb(x...) cout << #x << " : ";printer(x);
#else
#define deb(x...) ;
#endif
#define all(x) x.begin(),x.end()
#define F first
#define S second
#define pb push_back

typedef long long ll;
typedef pair<int,int> pii;


const ll mod = 1e9 + 7;
const ll N = 3e5 + 12;
int n, m, used[N], id[N], vec[N];
vector<int> g[N], ord;

void dfs(int v){
    if(used[v])
        return;
    used[v] = 1;
    for(int to : g[v]){
        dfs(to);
    }
    ord.push_back(v);
}
void solve(){
    cin >> n >> m;
    for(int i = 1; i <= m; i++){
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        vec[i] = i;
    }
    sort(vec + 1, vec + 1 + n, [&](int a, int b){
        return g[a].size() > g[b].size();
    });
    for(int i = 1; i <= n; i++){
        sort(g[i].begin(), g[i].end(), [&](int a, int b){
            return g[a].size() > g[b].size();
        });
    }
    for(int i = 1; i <= n ;i++){
        dfs(vec[i]);
    }
    reverse(all(ord));
    int cnt = 0;
    for(int i = 0; i < ord.size(); i++){
        id[ord[i]] = i;
    }
    for(int v : ord){
        for(int to : g[v]){
            cnt += (id[v] <  id[to]);
        }
    }
    if(cnt >= (m + 1)/ 2){
        for(int v : ord){
            cout << v << " ";
        }
        cout << '\n';
    }else{
        cout << -1 << '\n';
    }


    ord.clear();
    for(int i = 1; i <= n; i++){
        g[i].clear();
        used[i] = 0;
        id[i] = 0;
        vec[i] = 0;
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);
    int T = 1;
    cin>>T;
    while(T--){
        solve();
    }
}
