#include "bits/stdc++.h"
using namespace std;

void printer(){
    cout << '\n';
}
template<typename T, typename... V>
void printer(T t, V... v){
    cout << t << ' ';
    printer(v...);
}

#ifndef ONLINE_JUDGE
#define deb(x...) cout << #x << " : ";printer(x);
#else
#define deb(x...) ;
#endif
#define all(x) x.begin(),x.end()
#define F first
#define S second
#define pb push_back

typedef long long ll;
typedef pair<int,int> pii;


const ll mod = 1e9 + 7;
const ll N = 3e5 + 12;
int n, m, used[N], id[N], vec[N];
vector<int> g[N], ord;

void dfs(int v){
    if(used[v])
        return;
    used[v] = 1;
    for(int to : g[v]){
        dfs(to);
    }
    ord.push_back(v);
}
void solve(){
    cin >> n >> m;
    for(int i = 1;i <= n; i++){
        vec[i] = i;
    }
    for(int i = 1; i <= m; i++){
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
    }
    for(int i = 1; i <= n ;i++){
        if(!used[i]){
            used[i] = 1;
            ord.push_back(i);
            for(auto to : g[i]){
                if(!used[to]){
                    ord.pb(to);
                    used[to] = 1;
                }
            }

        }
    }
    for(int i = 1; i <= n; i++){
        if(!count(all(ord),i))ord.pb(i);
    }
    for(int v : ord){
        cout << v << " ";
    }


    ord.clear();
    for(int i = 1; i <= n; i++){
        g[i].clear();
        used[i] = 0;
        id[i] = 0;
        vec[i] = 0;
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);
    int T = 1;
    cin>>T;
    while(T--){
        solve();
        cout<<"\n";
    }
}
