#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define nl '\n'
#define mp make_pair
#define F first 
#define S second
#define in insert
#define sz(x) (int)x.size()
#define pii pair <int, int>
#define pll pair <ll, ll>
#define all(x) x.begin(), x.end()


const int mxn = 1e6 + 123;
const int mnn = 1e3 + 10;
const ll mod = 1e9 + 7;
const int N = (int)1e5 + 123;

using namespace std;

int n, pos[mxn];
vector<int> g[mxn];
bool used[mxn];

vector<int> topsort;

void dfs(int v) {
	used[v] = true;
	topsort.push_back(v);
	for(int i = 0; i < g[v].size(); i++) {
		int to = g[v][i];
		if(used[to] == false) {
			dfs(to);
		}
	}
}

void solve() {
	int n, m;
	for(int i = 1; i <= n; i++) {
		g[i].clear();
		used[i] = false;
	}
	topsort.clear();
	cin >> n >> m;
	for(int i = 1; i <= m; i++) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
	}

	for(int i = 1; i <= n; i++) {
		if(used[i] == 0) {
			dfs(i);
		}
	}
	int k = 0;
	for(int i = 0; i < topsort.size(); i++) {
		pos[topsort[i]] = i;
	}
	for(int i = 1; i <= n; i++) {
		for(auto to : g[i]) {
			if(pos[i] < pos[to]) {
				k++;
			}
		}
	}
	if(k >= (m + 1) / 2) {
		for(int v : topsort) {
			cout << v << ' ';
		}
		cout << nl;
	} else {
		assert(false);
	}
}

int main () {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	string path = filesystem::current_path().string();

	if (path == "C:\\Users\\qf\\Documents") {
		freopen("input", "r", stdin);
		freopen("output", "w", stdout);
	}

	int t = 1;
	cin >> t;
	while(t--) {
		solve();
	}
}