#include <bits/stdc++.h>

#define pb push_back
#define sz(x) (x).size()

using namespace std;
const int MAXN = 1e5 + 5;
int n, m, w[MAXN], pos[MAXN];
vector<int> g[MAXN], lst;
void dfs(int v) {
    w[v] = 1;
    for (int i = 0; i < sz(g[v]); ++i) {
        int to = g[v][i];
        if(!w[to]) {
            dfs(to);
        }
    }
    lst.pb(v);
}
void solve() {
    lst.clear();
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        w[i] = pos[i] = 0;
        g[i].clear();
    }
    vector<pair<int, int> > cur;
    for (int i = 1; i <= m; ++i) {
        int x, y;
        cin >> x >> y;
        cur.pb(make_pair(x, y));
        g[x].pb(y);
    }
    for (int i = 1; i <= n; ++i) {
        if(!w[i]) {
            dfs(i);
        }
    }
    reverse(lst.begin(), lst.end());
    for (int i = 0; i < sz(lst); ++i) {
        pos[lst[i]] = i + 1;
    }
    int cnt = 0;
    for (int i = 0; i < sz(cur); ++i) {
        if(pos[cur[i].second] > pos[cur[i].first]) cnt++;
    }
    if(cnt < (m + 1) / 2) cout << "-1\n";
    else {
        for (int i = 0; i < sz(lst); ++i) cout << lst[i] << ' ';
        cout << '\n';
    }
}
int main() {
    int tt = 1;
    cin >> tt;
    while (tt--) solve();
}
