#include <bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
#define ll long long
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define vt vector
#define pr pair
const int N = 1e5 + 5;
const int mod = 1e9 + 7;

int mult(int &x, int &y) {
    return int(1ll*x*y%mod);
}
int sum(int x, int &y) {
    x += y;
    if(x >= mod) {
        x -= mod;
    }
    return x;
}
int sub(int x, int &y) {
    x -= y;
    if(x<0) {
        x += mod;
    }
    return x;
}
int binpow(int x, int n) {
    if(n == 0) {
        return 1;
    }
    if(n&1^1) {
        int y = binpow(x, n/2);
        return mult(y, y);
    }
    int y = binpow(x, n-1);
    return mult(y, x);
}

int a[N], b[N];
pr<int, int> c[N];
void solve() {
    int n; cin >> n;
    for(int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    for(int i = 1; i <= n; ++i) {
        cin >> b[i];
    }
    for(int i = 1; i <= n; ++i) {
        c[i] = {b[i], b[i] - a[i]};
        if(c[i].ss < 0) {
            cout << -1 << "\n";
            return;
        }
    }
    sort(c + 1, c + n + 1);
    for(int i = 2; i <= n; ++i) {
        if(c[i].ss < c[i - 1].ss) {
            cout << -1 << "\n";
            return;
        }
        if(c[i].ff == c[i - 1].ff && c[i].ss != c[i - 1].ss) {
            cout << -1 << "\n";
            return;
        }
    }
    cout << c[n].ss << "\n";
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}