#include <bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
#define ll long long
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define vt vector
#define pr pair
const int N = 1e5 + 5;
const int mod = 1e9 + 7;
const int inf = 1e9;

int mult(int &x, int &y) {
    return int(1ll*x*y%mod);
}
int sum(int x, int &y) {
    x += y;
    if(x >= mod) {
        x -= mod;
    }
    return x;
}
int sub(int x, int &y) {
    x -= y;
    if(x<0) {
        x += mod;
    }
    return x;
}
int binpow(int x, int n) {
    if(n == 0) {
        return 1;
    }
    if(n&1^1) {
        int y = binpow(x, n/2);
        return mult(y, y);
    }
    int y = binpow(x, n-1);
    return mult(y, x);
}

void solve() {
    int n, m;
    cin >> n >> m;
    string s[n];
    vt<int> cnt(m, 0);
    for(int i = 0; i < n; i++){
        cin >> s[i];
        int sz = s[i].size();
        for(int j = 0; j < sz; j++){
            if(s[i][j] != s[i][0])break;
            cnt[s[i][j] - 'a']++;
            if(j == sz - 1){
                cnt[j] = inf;
            }
        }
    }
    int mx = 0;
    for(int i = 0; i < m; i++){
        if(cnt[i] < cnt[mx])mx = i;
    }
    if(cnt[mx] == inf){
        cout << "NO";
    }
    else {
        for(int i = 0; i <= cnt[mx]; i++)cout << char(mx + 'a');
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}