import java.io.*;
import java.util.*;

//TIP To <b>Run</b> code, press <shortcut actionId="Run"/> or
// click the <icon src="AllIcons.Actions.Execute"/> icon in the gutter.
public class Main {
    static class Item {
        int pVal;
        int hVal;
        public Item(int pVal, int hVal) {
            this.pVal = pVal;
            this.hVal = hVal;
        }

    }
    public static void main(String[] args) throws IOException {
        //BufferedReader reader = new BufferedReader(new FileReader("src/input.txt"));
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        int n = Integer.parseInt(reader.readLine());
        int[] res = new int[n];
        for (int i = 0; i < n; i++) {
            int nMountains = Integer.parseInt(reader.readLine());
            String[] p = reader.readLine().split(" ");
            String[] h = reader.readLine().split(" ");
            int[][] arr = new int[nMountains][2];
            List<Item> arr1 = new ArrayList<>();

            for (int j = 0; j < nMountains; j++) {
                arr[j][0] = Integer.parseInt(p[j]);
                arr[j][1] = Integer.parseInt(h[j]);
                Item item = new Item(Integer.parseInt(p[j]), Integer.parseInt(h[j]));
                arr1.add(item);
            }
            bubbleSort(arr1);

            int max = arr1.get(0).hVal - arr1.get(0).pVal;
            for (int j = 1; j < nMountains; j++) {
                Item prev = arr1.get(j - 1);
                Item cur = arr1.get(j);
                if (prev.hVal > cur.hVal || (prev.hVal >= cur.hVal && prev.pVal < cur.pVal)) {
                    max = -1;
                    break;
                }
                int dif = cur.hVal - cur.pVal;
                if (dif > max) max = dif;
            }

            res[i] = max;
//            for (int j = 0; j < nMountains; j++) {
//                System.out.println(arr1.get(j).pVal + " " + arr1.get(j).hVal);;
//            }
        }

        for (int i = 0; i < n; i++) {
            System.out.println(res[i]);
        }

    }

    public static void bubbleSort(List<Item> arr) {
        for (int i = 0; i < arr.size(); i++) {
            for (int j = i + 1; j < arr.size(); j++) {
                if (arr.get(i).pVal > arr.get(j).pVal) {
                    Item temp = arr.get(i);
                    arr.set(i, arr.get(j));
                    arr.set(j, temp);
                } else if (arr.get(i).pVal == arr.get(j).pVal) {
                    if (arr.get(i).hVal > arr.get(j).hVal) {
                        Item temp = arr.get(i);
                        arr.set(i, arr.get(j));
                        arr.set(j, temp);
                    }
                }
            }
        }
    }
}