import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.Comparator;
import java.util.StringTokenizer;

public class Main {
    public static void main(String[] args) {
        FastScanner sc = new FastScanner(System.in);
        int t = sc.nextInt();
        while (t-- > 0) {
            int n = sc.nextInt();
            long[][] arr = new long[n][2];
            for (int i = 0; i < n; i++) {
                arr[i][0] = sc.nextInt();
            }
            for (int i = 0; i < n; i++) {
                arr[i][1] = sc.nextInt();
            }

            Arrays.sort(arr, new Comparator<long[]>() {
                @Override
                public int compare(long[] o1, long[] o2) {
                    if (o1[0] == o2[0]) return (int) (o1[1] - o2[1]);
                    return (int) (o1[0] - o2[0]);
                }
            });
            long[] dp = new long[n];
            if (n == 1){
                System.out.println(arr[0][1] - arr[0][0]);
                continue;
            }
//            for (int i = 0; i < n; i++)
//            System.out.println(Arrays.toString(arr[i]));
            dp[0] = arr[0][1] - arr[0][0];
            boolean check = false;
            for(int i = 1; i < n ; i++){
                dp[i] += arr[i][1] - arr[i][0];
//                System.out.println( arr[i][1] +" " + arr[i][0] + " " + dp[i - 1]);
//                System.out.println(arr[i][1] - arr[i][0] - dp[i - 1]);
                if (dp[i] < 0){
                    System.out.println(-1);
                    check = true;
                    break;
                }
            }
            if (check){
                continue;
            }
            System.out.println(dp[n - 1]);
        }


    }

    static class FastScanner {
        private BufferedReader reader = null;
        private StringTokenizer tokenizer = null;

        public FastScanner(InputStream in) {
            reader = new BufferedReader(new InputStreamReader(in));
            tokenizer = null;
        }

        public String next() {
            if (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public String nextLine() {
            if (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    return reader.readLine();
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken("\n");
        }

        public long nextLong() {
            return Long.parseLong(next());
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public double nextDouble() {
            return Double.parseDouble(next());
        }
    }
}