#include <bits/stdc++.h> 

using namespace std;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> e(n);
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		v--, u--;
		e[v].push_back(u);
	}
	auto check = [&](vector<int> order) {
		int cnt = 0;
		for (int i = 0; i < n; i++) {
			for (int v : e[i]) {
				if (v > i) {
					cnt++;
				}
			}
		}
	
		return cnt >= (m + 1) / 2;	
	};
	vector<int> ans(n);
	iota(ans.begin(), ans.end(), 0);
	if (!check(ans)) {
		reverse(ans.begin(), ans.end());
	}
	
	for (auto v : ans) {
		cout << v + 1 << " ";
	}
	cout << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
	
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
    return 0;
}
