﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <list>
#include <cmath>

using namespace std;

struct Circle {
    long long x;
    long long y;
    long long r;
};

int main()
{
  //  #define int long long
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    int tests;
    cin >> tests;

    while (tests--) {
        int circleCount;
        cin >> circleCount;

        int eightsCount = 0;
        vector<Circle> circles(circleCount);

        for (int i = 0; i < circleCount; ++i) {
            Circle c;
            cin >> c.x;
            cin >> c.y;
            cin >> c.r;
            circles[i] = c;
        }

        for (int i = 0; i < circleCount - 1; ++i) {
            for (int j = i + 1; j < circleCount; ++j) {
                eightsCount += sqrt((circles[j].x - circles[i].x) * (circles[j].x - circles[i].x) + 
                    (circles[j].y - circles[i].y) * (circles[j].y - circles[i].y)) == circles[i].r + circles[j].r;
            }
        }

        cout << eightsCount << endl;
    }
}