#include<bits/stdc++.h>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;

bool check(vector<pii> a, vector<pii> b) {
    int n = a.size();
    int m = b.size();
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    ll sum_a = 0;
    ll sum_b = 0;
    ll K_a = 0;
    ll K_b = 0;
    for (int i = 0, j = 0; i < n; ++i) {
        auto [x, m] = a[i];
        K_a += m;
        sum_a += x * 1ll * m;
        while (j < m && K_b + b[j].second < K_a) {
            K_b += b[j].second;
            sum_b += b[j].first * 1ll * b[j].second;
            ++j;
        }
        assert(j != m);
        ll cur_b = sum_b + (K_a - K_b) * b[j].first;
        if (sum_a > cur_b) {
            return true;
        }
    }
    sum_a = 0;
    sum_b = 0;
    K_a = 0;
    K_b = 0;
    for (int i = 0, j = 0; j < m; ++j) {
        auto [x, m] = b[j];
        K_b += m;
        sum_b += x * 1ll * m;
        while (i < n && K_a + a[j].second < K_b) {
            K_a += a[i].second;
            sum_a += a[i].first * 1ll * a[i].second;
            ++i;
        }
        if (i == n) {
            break;
        }
        ll cur_a = sum_a + (K_b - K_a) * a[i].first;
        if (cur_a > sum_b) {
            return true;
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(0); 
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<pair<int, int>> red, blue;
        ll total_red = 0;
        ll total_blue = 0;
        for (int i = 0; i < n; ++i) {
            int x, m;
            char c;
            cin >> x >> m >> c;
            if (c == 'R') {
                total_red += m;
                red.emplace_back(x, m);
            } else {
                total_blue += m;
                blue.emplace_back(x, m);
            }
        }
        if (total_red == total_blue) {
            cout << "Draw 0 0\n";
            continue;
        }
        if (total_red > total_blue) {
            auto& [x, m] = red.back();
            --m;
            red.emplace_back(x + 1, 1);
            if (check(blue, red)) {
                cout << "Draw 0 0\n";
            } else {
                cout << "First " << x << " +\n";
            }
        } else {
            if (check(red, blue)) {
                cout << "Draw " << red.back().first << " +\n";
            } else {
                cout << "Second\n";
            }
        }
    }
}