#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll mod = 998244353;

const int N = 1e6;

ll f[N], g[N];
int a[2][N];
ll dp[2][N][3];

int main() {
    ios_base::sync_with_stdio(0); 
    cin.tie(0);

    for (int n = 1; n < N; ++n) {
        f[n] = (3 * f[n - 1] + 2) % mod;
        g[n] = (g[n - 1] + 1 + f[n - 1]) % mod;
    }

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        for (int t = 0; t < 2; ++t) {
            for (int i = 0; i < n; ++i) {
                cin >> a[t][i];
                --a[t][i];
            }
        }
        while (n && a[0][n - 1] == a[1][n - 1]) {
            --n;
        }
        if (n == 0) {
            cout << "0\n";
            continue;
        }
        for (int t = 0; t < 2; ++t) {
            for (int i = 0; i < n; ++i) {
                for (int x = 0; x < 3; ++x) {
                    if (x == a[t][i]) {
                        dp[t][i + 1][x] = dp[t][i][x];
                    } else {
                        if (abs(x - a[t][i]) == 1) {
                            int y = 3 ^ x ^ a[t][i];
                            dp[t][i + 1][x] = dp[t][i][y] + 1;
                            if (abs(x - y) == 1) {
                                dp[t][i + 1][x] += g[i];
                            } else {
                                dp[t][i + 1][x] += f[i];
                            }
                        } else {
                            dp[t][i + 1][x] = dp[t][i][x] + 1 + f[i] + 1 + f[i];
                        }
                        dp[t][i + 1][x] %= mod;
                    }
                }
            }
        }
        ll ans = 0;
        int x = a[0][n - 1];
        int y = a[1][n - 1];
        if (abs(x - y) == 1) {
            int z = 3 ^ x ^ y;
            ans = dp[0][n - 1][z] + dp[1][n - 1][z] + 1;
        } else {
            //cout << dp[0][n - 1][y] << ' ' << f[n - 1] << ' ' << dp[1][n - 1][x] << endl;
            ans = dp[0][n - 1][y] + 1 + f[n - 1] + 1 + dp[1][n - 1][x];
        }
        ans %= mod;
        cout << ans << '\n';
    }
}