#include <bits/stdc++.h>

#define ll long long
#define ull unsigned long long
#define uint unsigned int
#define ld long double
#define f first
#define s second
#define mp make_pair
#define pb push_back
#define ppb pop_back
#define sk continue
#define br break
#define r0 return 0
#define pll pair<ll, ll>

using namespace std;

const int INF = (int)(1e9) + 7;
const ll INFLL = (ll)(1e18) + 7;
const ld Pi = acos(-1);
const int mxn = 1e6 + 5;

const int MOD = 998244353;

void solve();

int precalced_move_1[200000], precalced_move_2[200000];

void precalc(){

    precalced_move_1[1] = 1;
    precalced_move_2[1] = 2;

    for(int i = 2; i <= 100000; i ++){
        precalced_move_1[i] = precalced_move_2[i - 1] + 1 + precalced_move_1[i - 1];
        while(precalced_move_1[i] >= MOD){
            precalced_move_1[i] -= MOD;
        }
        precalced_move_2[i] = (precalced_move_1[i] << 1);
        if(precalced_move_2[i] >= MOD){
            precalced_move_2[i] -= MOD;
        }
    }

    /*for(int i = 1; i <= 3; i ++){
        cout << i << ":\t" << precalced_move_1[i] << ' ' << precalced_move_2[i] << '\n';
    }*/

    return;
}

int main(){

    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    //cout.precision(20);

    precalc();

    int t;
    cin >> t;

    for(int t_id = 0; t_id < t; t_id ++){
        solve();
    }

    return 0;
}

vector <int> state_a(200000), state_b(200000);

int get_state_id(int n, vector <int> &state, bool is_reversed){

    if(is_reversed){
        state[n] = 4 - state[n];
    }

    if(n == 1){
        return state[1] - 1;
    }

    if(state[n] == 1){
        return get_state_id(n - 1, state, is_reversed);
    }

    if(state[n] == 2){
        int ans = precalced_move_2[n - 1] + 1 + get_state_id(n - 1, state, !is_reversed);
        while(ans >= MOD){
            ans -= MOD;
        }
        return ans;
    }

    int ans = precalced_move_2[n] - get_state_id(n, state, !is_reversed);
    if(ans < 0){
        ans += MOD;
    }

    return ans;
}

void solve(){

    int n;
    cin >> n;

    for(int i = 1; i <= n; i ++){
        cin >> state_a[i];
    }
    for(int i = 1; i <= n; i ++){
        cin >> state_b[i];
    }

    for(int i = n; i >= 1; i --){
        if(state_a[i] > state_b[i]){
            //cout << "SWAPPED!\n";
            swap(state_a, state_b);
            break;
        }
        if(state_a[i] < state_b[i]){
            break;
        }
    }

    int state_a_id = get_state_id(n, state_a, false);
    int state_b_id = get_state_id(n, state_b, false);

    //cout << '\t' << state_a_id << ' ' << state_b_id << '\n';

    int state_diff = state_b_id - state_a_id;
    if(state_diff < 0){
        state_diff += MOD;
    }

    cout << state_diff << '\n';

    return;
}
