#include <bits/stdc++.h>

#define ll long long
#define ull unsigned long long
#define uint unsigned int
#define ld long double
#define f first
#define s second
#define mp make_pair
#define pb push_back
#define ppb pop_back
#define sk continue
#define br break
#define r0 return 0
#define pll pair<ll, ll>

using namespace std;

const int INF = (int)(1e9) + 7;
const ll INFLL = (ll)(1e18) + 7;
const ld Pi = acos(-1);
const int mxn = 1e6 + 5;

const int MOD = 998244353;

void solve();

ll precalced_move_1[200000], precalced_move_2[200000];

void precalc(){

    precalced_move_1[1] = 1;
    precalced_move_2[1] = 2;

    for(int i = 2; i <= 100000; i ++){
        precalced_move_1[i] = precalced_move_2[i - 1] + 1 + precalced_move_1[i - 1];
        while(precalced_move_1[i] >= MOD){
            precalced_move_1[i] -= MOD;
        }
        precalced_move_2[i] = (precalced_move_1[i] << 1);
        if(precalced_move_2[i] >= MOD){
            precalced_move_2[i] -= MOD;
        }
    }

    /*for(int i = 1; i <= 3; i ++){
        cout << i << ":\t" << precalced_move_1[i] << ' ' << precalced_move_2[i] << '\n';
    }*/

    return;
}

int main(){

    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    //cout.precision(20);

    precalc();

    int t;
    cin >> t;

    for(int t_id = 0; t_id < t; t_id ++){
        solve();
    }

    return 0;
}

vector <ll> state_a(200000), state_b(200000);

ll get_state_id(int n, vector <ll> &state, bool is_reversed){

    int curr_state = state[n];

    if(is_reversed){
        curr_state = 4 - curr_state;
    }

    if(n == 1){
        return curr_state - 1;
    }

    if(curr_state == 1){
        return get_state_id(n - 1, state, is_reversed);
    }

    if(curr_state == 2){
        ll ans = precalced_move_2[n - 1] + 1 + get_state_id(n - 1, state, !is_reversed);
        while(ans >= MOD){
            ans -= MOD;
        }
        return ans;
    }

    ll ans = precalced_move_2[n] - get_state_id(n, state, !is_reversed);
    if(ans < 0){
        ans += MOD;
    }

    return ans;
}

void solve(){

    int n;
    cin >> n;

    for(int i = 1; i <= n; i ++){
        cin >> state_a[i];
    }
    for(int i = 1; i <= n; i ++){
        cin >> state_b[i];
    }

    bool is_mirrored = false;
    for(int i = n; i >= 1; i --){
        int curr_a = state_a[i], curr_b = state_b[i];
        if(is_mirrored){
            curr_a = 4 - curr_a;
            curr_b = 4 - curr_b;
        }
        if(curr_a > curr_b){
            //cout << "SWAPPED!\n";
            swap(state_a, state_b);
            break;
        }
        if(curr_a < curr_b){
            break;
        }
        if(curr_a == 2){
            is_mirrored = !is_mirrored;
        }
    }

    //cout << "Getting a...\n";
    ll state_a_id = get_state_id(n, state_a, false);
    //cout << "Getting b...\n";
    ll state_b_id = get_state_id(n, state_b, false);

    //cout << '\t' << state_a_id << ' ' << state_b_id << '\n';

    int state_diff = state_b_id - state_a_id;
    if(state_diff < 0){
        state_diff += MOD;
    }

    cout << state_diff << '\n';

    return;
}
