#include <bits/stdc++.h>

#define ll long long
#define ull unsigned long long
#define uint unsigned int
#define ld long double
#define f first
#define s second
#define mp make_pair
#define pb push_back
#define ppb pop_back
#define sk continue
#define br break
#define r0 return 0
#define pll pair<ll, ll>

using namespace std;

const int INF = (int)(1e9) + 7;
const ll INFLL = (ll)(1e18) + 7;
const ld Pi = acos(-1);
const int mxn = 1e6 + 5;

void solve();

int a[200000];
int b[200000];

int main(){

    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    //cout.precision(20);

    int t;
    cin >> t;

    for(int t_id = 0; t_id < t; t_id ++){
        solve();
    }

    return 0;
}

void solve(){

    int n;
    cin >> n;

    // set <int> compressor_set;

    for(int i = 0; i < n; i ++){
        cin >> a[i];
        // compressor_set.insert(a[i]);
    }
    for(int i = 0; i < n; i ++){
        cin >> b[i];
        // compressor_set.insert(b[i]);
    }

    map <int, int> pairs;
    for(int i = 0; i < n; i ++){
        if(a[i] > b[i]){
            cout << "-1\n";
            return;
        }
        if(!pairs.count(b[i])){
            pairs[b[i]] = a[i];
            continue;
        }
        if(pairs[b[i]] != a[i]){
            cout << "-1\n";
            return;
        }
    }

    vector <pair <int, int> > mountains;
    for(int i = 0; i < n; i ++){
        mountains.pb({b[i], a[i]});
    }
    sort(mountains.begin(), mountains.end());

    for(int i = 1; i < n; i ++){
        if(mountains[i - 1].s <= mountains[i].s){
            continue;
        }
        cout << "-1\n";
        return;
    }

    vector <pair <int, int> > ops; // .f -- h, .s -- op_cnt
    for(int i = 0; i < n; i ++){
        ops.pb({b[i], b[i] - a[i]});
    }
    sort(ops.begin(), ops.end());

    for(int i = 1; i < n; i ++){
        if(ops[i].s < ops[i - 1].s){
            cout << "-1\n";
            return;
        }
    }

    cout << ops[n - 1].s << '\n';

    return;
}
