﻿#include <bits/stdc++.h>

using namespace std;

const int N = 2 * 1e5 + 11;

int n, m;

vector < int > g[N], ans;
bool used[N];

void dfs(int v) {
  used[v] = 1;
  for (auto to : g[v]) {
    if (!used[to]) {
      dfs(to);
    }
  }
  ans.push_back(v);
}

void clearAll() {
  ans.clear();
  for (int i = 1; i <= n; i++) {
    g[i].clear();
    used[i] = false;
  }
}

void func() {
  cin >> n >> m;
  clearAll();
  for (int i = 1; i <= m; i++) {
    int u, v;
    cin >> u >> v;
    g[u].push_back(v);
  }
  for (int i = 1; i <= n; i++) {
    if (!used[i]) {
      dfs(i);
    }
  }
  reverse(ans.begin(), ans.end());

  for (auto x : ans)
    cout << x << ' ';
  cout << '\n';
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);    
  int t;
  cin >> t;
  while (t--) {
    func();  
  }
}