﻿#include <bits/stdc++.h>

using namespace std;

const int N = 1e6 + 11;

int n, m;
int pos[N];
pair < int, int > d[N];
vector < pair < int, int > > g[N], r;
vector < int > ans;
bool used[N];

void dfs(int v) {
  used[v] = 1;
  for (auto to : g[v]) {
    if (!used[to.second]) {
      dfs(to.second);
    }
  }
  ans.push_back(v);
}

void clearAll() {
  ans.clear();
  r.clear();
  for (int i = 1; i <= n; i++) {
    g[i].clear();
    used[i] = false;
    d[i].first = 0;
    d[i].second = i;
    pos[i] = i;
  }
}

void func() {       
  cin >> n >> m;
  clearAll();
  
  map < int, set < int > > s;
  for (int i = 1; i <= m; i++) {
    int u, v;
    cin >> u >> v;
    d[u].first--;
    d[v].first++;
    r.push_back(make_pair(u, v));
    s[u].insert(v);
  }

  sort(d + 1, d + 1 + n);
  for (int i = 1; i <= n; i++)
    pos[d[i].second] = i;

  int pls = 0;
  for (auto v : r) {
    if (pos[v.first] < pos[v.second]) pls++;  
  }

  for (int i = 1; i <= n; i++) {
    int cnt = 0;
    for (int j = 1; j <= n; j++) {
      if (pos[i] < pos[j] && s[i].find(j) != s[i].end())
        cnt++;
    }
    if (cnt < (m + 1) / 2) {
      cout << -1 << '/n';
      return;
    }
  }

  if (pls >= (m + 1) / 2) {
    for (int i = 1; i <= n; i++)
      cout << d[i].second << ' ';
  } else
    cout << -1;
  cout << '\n';
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);    
  int t;
  cin >> t;
  while (t--) {
    func();  
  }

  return 0;
}