﻿#include <bits/stdc++.h>

using namespace std;

const int N = 2 * 1e5 + 11;

int n, m;
pair < int, int > d[N];
vector < pair < int, int > > g[N];
vector < int > ans;
bool used[N];

void dfs(int v) {
  used[v] = 1;
  for (auto to : g[v]) {
    if (!used[to.second]) {
      dfs(to.second);
    }
  }
  ans.push_back(v);
}

void dfs1(int v) {
  used[v] = 1;
  for (auto to : g[v]) {
    if (!used[to.second]) {
      dfs1(to.second);
    }
  }
}

void clearAll() {
  ans.clear();
  for (int i = 1; i <= n; i++) {
    g[i].clear();
    used[i] = false;
    d[i].first = 0;
    d[i].second = i;
  }
}

void func() {
  cin >> n >> m;
  clearAll();
  
  vector < pair < int, int > > r;
  for (int i = 1; i <= m; i++) {
    int u, v;
    cin >> u >> v;
    r.push_back(make_pair(u, v));
    g[u].push_back(make_pair(0, v));
    d[v].first++;
  }
  for (int i = 1; i <= n; i++) {
    for (int j = 0; j < g[i].size(); j++) {
      g[i][j].first = d[g[i][j].second].first;
    }    
    sort(g[i].begin(), g[i].end());
  }
  sort(d + 1, d + 1 + n);
  for (int i = 1; i <= n; i++) {
    if (!used[d[i].second]) {
      dfs(d[i].second);
    }
  }
  reverse(ans.begin(), ans.end());

  for (auto x : ans)
    cout << x << ' ';
  cout << '\n';
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);    
  int t;
  cin >> t;
  while (t--) {
    func();  
  }
}