﻿#include <bits/stdc++.h>

using namespace std;

const int N = 4 * 1e5 + 11;

int n, m;
int pos[N];
pair < int, int > d[N];
vector < pair < int, int > > g[N], r;
vector < int > ans;
bool used[N];

void dfs(int v) {
  used[v] = 1;
  for (auto to : g[v]) {
    if (!used[to.second]) {
      dfs(to.second);
    }
  }
  ans.push_back(v);
}

void clearAll() {
  ans.clear();
  r.clear();
  for (int i = 1; i <= n; i++) {
    g[i].clear();
    used[i] = false;
    d[i].first = 0;
    d[i].second = i;
  }
}

void func() {
  cin >> n >> m;
  clearAll();
  
  for (int i = 1; i <= m; i++) {
    int u, v;
    cin >> u >> v;
    g[u].push_back(make_pair(0, v));
    d[v].first++;
    r.push_back(make_pair(u, v));
  }
  
  for (int i = 1; i <= n; i++) {
    for (int j = 0; j < g[i].size(); j++) {
      g[i][j].first = d[g[i][j].second].first;
    }    
    sort(g[i].begin(), g[i].end());
  }

  sort(d + 1, d + 1 + n);
  for (int i = 1; i <= n; i++) {
    if (!used[d[i].second]) {
      dfs(d[i].second);
    }
  }

  reverse(ans.begin(), ans.end());
  for (int i = 0; i < ans.size(); i++)
    pos[ans[i]] = i + 1;

  int pls = 0;
  for (auto v : r) {
    if (pos[v.first] < pos[v.second]) pls++;  
  }

  if (pls < (m + 1) / 2) {
    cout << -1 << '\n';
    return;
  }
  for (auto x : ans)
    cout << x << ' ';
  cout << '\n';
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);    
  int t;
  cin >> t;
  while (t--) {
    func();  
  }
}