#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define fi first
#define se second
#define pb push_back
#define vi vector<int>
#define pii pair<int,int>
typedef long long ll;

using namespace std;
using namespace __gnu_pbds;
typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

void solve() {
    int n;
    cin >> n;
    int h[n], p[n];
    map<int,int> cnt, diff;
    for(int i = 0; i < n; ++i) cin >> h[i];
    for(int i = 0; i < n; ++i) {
        cin >> p[i];
    }

    for(int i = 0; i < n; ++i) {
        if(p[i] < h[i]) {
            cout << "-1\n";
            return;
        }
        if (cnt.count(p[i]) && cnt[p[i]] != h[i]) {
            cout << "-1\n";
            return;
        }
        cnt[p[i]] = h[i];
        diff[p[i]] = p[i] - h[i];
    }

    int last = 0, last2 = 0;
    for (auto [x, y]: cnt) {
        if (last > y) {
            cout << "-1\n";
            return;
        }
        last = y;
    }
    for (auto [x, y]: diff) {
        if (last2 > y) {
            cout << "-1\n";
            return;
        }
        last2 = y;
    }

    int mx = 0, pos = -1, mxp = -1;
    for (int i = 0; i < n; i++) {
        if(p[i] > mxp) {
            pos = i;
            mxp = p[i];
        }
        mx = max(mx, p[i] - h[i]);
    }
    assert(mx == mxp - h[pos]);
    cout << mx << '\n';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> s;

    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}
