#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define fi first
#define se second
#define pb push_back
#define vi vector<int>
#define pii pair<int,int>
#define nl '\n'
typedef long long ll;

using namespace std;
using namespace __gnu_pbds;
typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;
const int MAXN = 1e5+5;

bool used[MAXN];
vector<int> g[MAXN];

void solve() {
    int n, m;
    cin >> n >> m;
    for(int i = 0; i <= n; ++i) {
        used[i] = false;
        g[i].clear();
    }

    for(int i = 0; i < m; ++i) {
        int u,v;
        cin >> u >> v;
        g[u].pb(v);
    }

    int cnt = 0;
    for(int i = 1; i <= n; ++i) {
        for(int j = 0; j < g[i].size(); ++j) {
            if(used[g[i][j]] == false)
                ++cnt;
        }
        used[i] = true;
    }
    if(cnt >= (m + 1) / 2) {
        for(int i = 1; i <= n; ++i) cout << i << " ";
    } else {
        for(int i = n; i >= 1; --i) cout << i << " ";
    }
    cout << '\n';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}
