#include <bits/stdc++.h>
using namespace std;

int n , m;
set <int> used;
vector <int> height;
vector <vector <int>> g;

void dfs (int cur , int &cnt) {
	used.insert(cur);
	for (int i : g[cur]) {
		if (used.count(i) && height[cur] <= height[i]) {
			cnt += 1;
			height[i] = height[cur] + 1;
		} else if (!used.count(i)) {
			cnt += 1;
			height[i] = height[cur] + 1;
			dfs(i , cnt);
		}
	}
}

void solve() {
   	cin >> n >> m;
   	
   	g.clear();
   	g.resize(n + 1);
   	for (int i = 1 ; i <= m ; ++i) {
   		int u , v;
		cin >> u >> v;
		g[u].push_back(v); 
	}
	
	used.clear();
	int res = 0;
	height.resize(n + 1);
	for (int i = 1 ; i <= n ; ++i) {
		if (!used.count(i)) {
			int cnt = 0;
			dfs(i , cnt);
			res = max(res , cnt);
		}
	}
	
	if (res >= (m + 1) / 2) {
		vector <pair <int , int>> v;
		for (int i = 1 ; i <= n ; ++i) {
			v.emplace_back(height[i] , i);
		}	
		sort(v.begin() , v.end());
		for (int i = 0 ; i < v.size() ; ++i) {
			cout << v[i].second << " ";
		}
		cout << endl;
	} else {
		cout << "-1\n";
	}
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
