#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define pb(x) push_back(x)
#define all(x) (x.begin(), x.end())
#define rall(x) (x.rbegin(), x.rend())


void solve() {
  int n; cin >> n;

  vector<int> h(n), p(n);

  for (int i = 0 ; i < n ; i++) {
    cin >> h[i];
  }

  for (int i = 0 ; i < n ; i++) {
    cin >> p[i];
  }


  for (int i = 0 ; i < n ; i++) {
    if (h[i] <= p[i]) continue;
    cout << "-1" << endl;
    return;
  }

  map<int, int> m;

  for (int i = 0 ; i < n ; i++) {
    if (m[p[i]] != 0) {
      if (m[p[i]] != h[i]) {
        cout << "-1" << endl;
        return;
      }
    }
    m[p[i]] = h[i];
  }

  int res = 0;
  for (int i = 0 ; i < n ; i++) {
    res = max(res, p[i] - h[i]);
  }

  cout << res << endl;
}

int main() {
  int t = 1; cin >> t;
  ios_base::sync_with_stdio(false);
  cin.tie(NULL); cout.tie(NULL);
  while (t--) {
    solve();
  }
}

