#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define ll long long

pair<int, int> pairs[100005];
int temp[100005];

int main() {
	int t;
	cin >> t;
	
	for (int ad = 0; ad < t; ad++){
		int n;
		cin >> n;
		for (int i = 0; i < n; i++)
			cin >> temp[i];
		for (int i = 0; i < n; i++){
			int second;
			cin >> second;
			pairs[i] = {second, temp[i]};
		}
		sort(pairs, pairs+n);
		
		int prev = 0;
		bool ok = true;
		for (int i = 0; i < n; i++){
			int diff = pairs[i].first - pairs[i].second;
			if (diff < prev) {
				cout << -1 << endl;
				ok = false;
				break;
			}
			prev = diff;
		}
		if (ok)
			cout << pairs[n-1].first - pairs[n-1].second << endl;
	}
	
	return 0;
}
