def time_to_minutes(time):
    h, m = map(int, time.split(":"))
    return (h - 7) * 60 + m


def solve():
    n = int(input())
    alarms = [time_to_minutes(input().strip()) for _ in range(n)]
    additional_alarms = 0
    for i in range(1, n):
        gap = alarms[i] - alarms[i - 1]
        if gap > 10:

            additional_alarms += (gap - 1) // 10

    print(additional_alarms)

if __name__ == '__main__':
    solve()
