/*

Men janbasam lapyldap,
Sen janbasan lapyldap,
Ol janbasa lapyldap,
Kimder janar lapyldap?

*/

#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define all(x) (x).begin(),(x).end()

using namespace std;

const int N = (int)1e5 + 3, M = (int)1e6 + 7, SM = (int)1e3 + 5;
const int MOD = (int)1e9 + 7, INF = (int)1e18 + 9;

vector<vector<int>> adj;
vector<int> u, d, ans;
int n, m, mx = 0, chosen = 0;

void dfs(int v) {
    u[v] = 1;
    d[v] = 0;
    ans.pb(v);
    for(auto to : adj[v]) {
        if(!u[to]) {
            dfs(to);
            d[v] = max(d[v], d[to] + 1);
        }
        else {
            d[v] = max(d[v], d[v] + d[to] + 1);
        }
    }
}

void solve() {
    cin >> n >> m;

    adj = vector<vector<int>>(n+1);
    u = vector<int>(n+1);
    d = vector<int>(n+1, -1);

    for(int i = 0; i < m; i++) {
        int x, y; cin >> x >> y;
        adj[x].pb(y);
    }

    for(int i = 1; i <= n; i++) {
        if(!u[i]) {
            dfs(i);
        }
    }

    for(int i = 1; i <= n; i++) {
        if(d[i] > mx) {
            mx = d[i];
            chosen = i;
        }
    }

    ans.clear();
    u = vector<int>(n+1);

    dfs(chosen);

    vector<int> pos(n+1);
    for(int i = 0; i < n; i++) {
        pos[ans[i]] = i;
    }

    int res = 0;
    for(int i = 1; i <= n; i++) {
        for(auto to : adj[i]) {
            if(pos[i] < pos[to]) res++;
        }
    }

    if(res >= (m+1) / 2) {
        for(auto it : ans) cout << it << " ";
        cout << "\n";
    }
    else {
        cout << "-1\n";
    }

    ans.clear();
    mx = 0, chosen = 0;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int tests = 1;
    cin >> tests;

    while(tests--) {
        solve();
    }

    return 0;
}
