/*

Men janbasam lapyldap,
Sen janbasan lapyldap,
Ol janbasa lapyldap,
Kimder janar lapyldap?

*/

#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define all(x) (x).begin(),(x).end()

using namespace std;

const int N = (int)1e5 + 3, M = (int)1e6 + 7, SM = (int)1e3 + 5;
const int MOD = (int)1e9 + 7, INF = (int)1e18 + 9;

void solve() {
    int n, k; cin >> n >> k;

    vector<vector<int>> ch(n+1);
    for(int i = 1; i <= n; i++) {
        string s; cin >> s;
        for(char c : s) ch[i].pb((int)c - 'a');
    }

    int len = n*k;
    string ans = "";

    for(int i = 1; i <= n; i++) {
        vector<int> u(k);

        if(i == 1) {
            for(int j = 1; j <= n; j++) {
                u[ch[j][0]] = 1;
            }

            for(int j = 0; j < k; j++) {
                if(!u[j]) {
                    cout << (char)(j + 'a');
                    return;
                }
            }
            u.clear();
        }

        string pref = "";
        for(int j = 1; j <= n; j++) {
            if(i != j) u[ch[j][0]] = 1;
        }
        for(int j = 0; j < 2*(int)ch[i].size(); j++) {
            pref += (char)ch[i][(j) % (int)ch[i].size()] + 'a';
            int nxt = (j+1) % (int)ch[i].size();
            u[ch[i][nxt]] = 1;
            for(int i = 0; i < k; i++) {
                if(!u[i]) {
                    if((j+1)+1 < len) {
                        len = j+1+1;
                        ans = pref + (char)(i + 'a');
                    }
                    break;
                }
            }
        }
    }

    if(ans == "") cout << "NO\n";
    else cout << ans << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int tests = 1;
    //cin >> tests;

    while(tests--) {
        solve();
    }

    return 0;
}
