/*

Men janbasam lapyldap,
Sen janbasan lapyldap,
Ol janbasa lapyldap,
Kimder janar lapyldap?

*/

#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define all(x) (x).begin(),(x).end()

using namespace std;

const int N = (int)1e5 + 3, M = (int)1e6 + 7, SM = (int)1e3 + 5;
const int MOD = (int)1e9 + 7, INF = (int)1e18 + 9;

string construct(int i) {
    return string(1, char(i + 'a'));
}

set<int> getPossibleNodes(string t, map<string, set<int>> prefixMp, map<string, set<int>> canCreateMp) {
    int n = t.size();

    set<int> newPossibleNodes;
    for (int i = 0; i <= n; i++) {
        string s1 = t.substr(0, i);
        string s2 = t.substr(i, n - i);
        // for all combinations
        set<int> set1 = canCreateMp[s1];
        set<int> set2 = prefixMp[s2];

        if (set1.size() * set2.size() == 0) {
            continue;
        }
        for (auto it : set2) {
            if (set1.count(it) != 0 && set1.size() == 1) {
                continue;
            }
            newPossibleNodes.insert(it);
        }
    }
    // return it
    return newPossibleNodes;
}

set<int> createAlternativeSet(int n, set<int> s) {
    set<int> out;
    for (int i = 0; i <= n - 1; i++) {
        if (s.count(i) == 0) out.insert(i);
    }
    return out;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<string> ss(n);

    map<string, set<int>> canCreateMp;
    for (int i = 0; i <= n - 1; i++) {
        canCreateMp[""].insert(i);
    }

    map<string, set<int>> prefixMp;
    for (int i = 0; i <= n - 1; i++) {
        cin >> ss[i];
        int sN = ss[i].size();
        string dpS = "";
        for (int j = 0; j <= sN - 1; j++) {
            dpS += string(1, ss[i][j]);
            prefixMp[dpS].insert(i);
        }
    }

    for (int i = 0; i <= n - 1; i++) {
        // check all cases for ss[i]
        string s = ss[i];
        int sN = s.size();
        string dpS = "";
        for (int index = 0; index <= sN; index++) {
            // generate checkedS;
            for (int newS = 0; newS <= k - 1; newS++) {
                string checkedS = dpS + construct(newS);

                // check for checkedS;
               set<int> possibleNodes = getPossibleNodes(checkedS, prefixMp, canCreateMp);
               if (possibleNodes.size() == 0) {
                    cout << checkedS;
                    return;
               }
                canCreateMp[checkedS] = possibleNodes;
            }
            if (index != sN) dpS += string(1, s[index]);
        }
    }

    cout << "NO";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    //int tests = 1;
    //cin >> tests;

    //while(tests--) {
        solve();
    //}

    return 0;
}
