#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

int main() {
    int cont;
    cin >> cont;
    vector<int> result_cont;

    for (int t = 0; t < cont; ++t) {
        int circles;
        cin >> circles;
        vector<vector<int>> options(circles, vector<int>(3));

        for (int i = 0; i < circles; ++i) {
            cin >> options[i][0] >> options[i][1] >> options[i][2];
        }

        int count = 0;

        for (int i = 0; i < circles; ++i) {
            for (int j = i + 1; j < circles; ++j) { // Проверяем только уникальные пары
                int dx = options[i][0] - options[j][0];
                int dy = options[i][1] - options[j][1];
                int r_sum = options[i][2] + options[j][2];
                if (dx * dx + dy * dy == r_sum * r_sum) {
                    count++;
                }
            }
        }

        result_cont.push_back(count);
    }

    for (int res : result_cont) {
        cout << res << endl;
    }

    return 0;
}
