def solve_erosion_alternative(test_cases):
    results = []

    for n, h, p in test_cases:
        possible = True
        max_diff = 0

        for i in range(n):
            if p[i] < h[i]:
                possible = False
                break
            max_diff = max(max_diff, p[i] - h[i])

        if not possible:
            results.append(-1)
        elif max_diff == 0:
            results.append(0)
        else:
            results.append(max_diff)

    return results

test_cases = [
    (4, [3, 2, 4, 2], [5, 3, 6, 2]),
    (1, [10], [100000]),
    (5, [1, 2, 3, 4, 5], [1, 2, 3, 4, 5]),
    (3, [1, 4, 6], [4, 1, 8])
]

output = solve_erosion_alternative(test_cases)

for result in output:
    print(result)
