#include <bits/stdc++.h>
using namespace std;

struct Node
{
    long long ptrs[ 100 ];
    string ans;
};

long long n, e;
string words[100];
bool sset[26];
bool loops[26];

int main( int argc, char *argv[] )
{
    ios_base::sync_with_stdio(false);
    cin >> n >> e;
    for( long long i = 0 ; i < n; ++i )
        cin >> words[ i ];
    if( n < e )
    {
        memset( sset, false, 26 );
        for( long long i = 0; i < n; ++i )
            sset[ words[i][0] - 'a' ] = true;
        for( long long i = 0; i < e; ++i )
        {
            if( !sset[ i ] )
            {
                std::cout << (char)(i + 'a');
                return 0;
            }
        }
    }
    else
    {
        memset( sset, false, 26 );
        memset( loops, false, 26 );
        for( long long i = 0; i < n; ++i )
        {
            bool has_loop = true;
            for( long long j = 0; j < words[i].size( ) - 1 && has_loop; ++j )
            {
                if( words[i][j] != words[i][j + 1] )
                {
                    has_loop = false;
                }
            }
            if( words[0].size( ) == 1 )
                has_loop = true;
            if( has_loop )
                loops[ words[i][0] - 'a' ] = true;
        }
        bool all_has_loop = true;
        for( long long i = 0; i < e && all_has_loop; ++i )
        {
            if( !loops[ i ] )
                all_has_loop = false;
        }
        if( all_has_loop )
        {
            cout << "NO";
            return 0;
        }

        queue<Node> my_queue;
        Node node;
        memset( node.ptrs, 0, sizeof( long long ) * 100 );
        memset( node.ptrs, false, sizeof( bool ) * 26 );
        node.ans = std::string();
        my_queue.push( node );

        while( !my_queue.empty() )
        {
            Node nd = my_queue.front();
            my_queue.pop();
            memset( sset, false, 26 );
            for( long long i = 0; i < n; ++i )
                sset[ words[i][ nd.ptrs[i] ] - 'a' ] = true;
            for( long long i = 0; i < e; ++i )
            {
                if( !sset[ i ] )
                {
                    nd.ans += (char)(i + 'a');
                    std::cout << nd.ans;
                    return 0;
                }
            }

            for( long long i = 0; i < n; ++i )
            {
                Node new_node = nd;
                new_node.ans += words[ i ][ nd.ptrs[ i ] ];
                new_node.ptrs[ i ] = ( nd.ptrs[ i ] + 1 ) % words[i].size( );
                my_queue.push( new_node );
            }
        }
    }
    return 0;
}
