def main():
    t = int(input())  # Читаем количество тестов
    results = []
    
    for _ in range(t):
        n = int(input())  # Количество гор
        h = list(map(int, input().split()))  # Текущие высоты
        p = list(map(int, input().split()))  # Высоты из книги
        
        valid = True
        max_years = 0
        
        for i in range(n):
            if p[i] < h[i]:  # Невозможно уменьшить до текущей высоты
                valid = False
                break
            max_years = max(max_years, p[i] - h[i])  # Максимальная разница
        
        if valid:
            results.append(str(max_years))
        else:
            results.append("-1")
    
    print("\n".join(results))

if __name__ == "__main__":
    main()
